#ifndef TETRAHEDRON_H
#define TETRAHEDRON_H

#include <QGLWidget>
#include <QImage>

class Tetrahedron : public QGLWidget
{
    Q_OBJECT

public:
    Tetrahedron(QWidget *parent = 0);
    //
    float debut_px;
    float debut_py;
    float debut_pz;
    float debut_rx;
    float debut_ry;
    float debut_rz;
    //
    float fin_px;
    float fin_py;
    float fin_pz;
    float fin_rx;
    float fin_ry;
    float fin_rz;
    //
    float delta_px;
    float delta_py;
    float delta_pz;
    float delta_rx;
    float delta_ry;
    float delta_rz;
    //
    float points[ 45 ][ 45 ][3];
    //
    GLfloat rotationX;
    GLfloat rotationY;
    GLfloat rotationZ;
    GLfloat deplacementX;
    GLfloat deplacementY;
    GLfloat zoom;
    GLfloat wg_percent;
    GLfloat start_opacity;
    GLfloat end_opacity;
    GLfloat delta_opacity;
    //
    int type3D;
    int wg_qualite;
    int frame_encoding;
    int tool;
    int isfog;
    int progress;
    int progress_anim;
    int duree;
    int poursuite;
    int wg_duree;
    int pause_debut;
    int pause_fin;
    QString path_fond;
    QString path_render;
    QString wg_tet_library;
    int numdiapo;
    int iseffect;
    int maxanim;
    QString nameanim;
    QImage a;
    QImage d;
    QImage null_img;
    QImage myimgrender;
    GLuint texture1;
    GLuint texture2;
    GLuint texture3;
    QString txt_sur_image;
    QFont myfont;
    QColor mycolor;
    int effet_titre;
    GLfloat x_titre;
    GLfloat v_titre;
    GLfloat fogcolor[4];
    QString table_effets[40][2];

protected:
    void paintGL();
    void mousePressEvent(QMouseEvent *event);
    void mouseMoveEvent(QMouseEvent *event);

public slots:
    void initializeGL();
    void change_fog_color();
    void sl_play();
    void sl_stop();
    void sl_charge_image(QString pathimg, QString pathfond);
    void updateMove();
    void grabgl();
    void grabframe(QString pathimg);
    void load_effet(int numeffet, QString nomeffet);
    void sl_mark_deb();
    void sl_mark_fin();
    void resizeGL(int width, int height);
    void sl_change_fond(QString myfic);
    void sl_brouillard(int);
    void sl_opacity(int);
    void sl_wait_stop();
    void sl_go_start();
    void sl_go_end();

private slots:

private:
    void draw();
    float w_x_p;
    float w_x_m;
    QImage t;
    QImage b;
    QImage c;
    QImage f;
    QPoint lastPos;
};

#endif
