/* ============================================================
 * File  : mainfrm.cpp
 * Author: Stephane Gibault
 * Date  : Sun Feb 4 2007
 * Description :
 *
 * 
 *  (C) 2007 by Stephane Gibault
 *
 * This program is free software; you can redistribute it
 * and/or modify it under the terms of the GNU General
 * Public License as published by the Free Software Foundation;
 * either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * ============================================================ */

#include <QtGui>
#include <QFileDialog>
#include <QProcess>
#include "mainfrm.h"
#include "tetrahedron.h"

mainfrm::mainfrm(QWidget *parent) : QDialog(parent)
{
	setupUi(this);
	Tetrahedron *mygl = new Tetrahedron(frame_ed3d);
	pntmygl = mygl;
	pntmygl->txt_sur_image = "";
	pntmygl->tool = 0;
	pntmygl->effet_titre = 0;
	pntmygl->x_titre = -1.8;
	pntmygl->v_titre = 1;
	frame_ed3d->setDisabled(true);
	path_photos_import = "~";
	pntmygl->mycolor.setRgb(255,255,255);
	zik_number = 0;
	zik_1->hide();
	total_audio = 0;
	must_redraw = 0;
	//
	gl_fond.load(QApplication::applicationDirPath() + "/Interface/fond.png");
	wg_comment.load(QApplication::applicationDirPath() + "/Interface/comment.png");
	wg_diapositive.load(QApplication::applicationDirPath() + "/Interface/diapositive.png");
	//
	stick_menu->setGeometry(10,7,98,32);
	M_BT_PROJ->raise();
	menu_projet->setGeometry(0,50,391,471);
	menu_projet->show();
	frame_topmenu->setDisabled(true);
	frame_toptimeline->setDisabled(true);
	contain_timeline->setDisabled(true);
	frame_fade->setDisabled(true);
	img_selection->hide();
	bt_img_effects->setDisabled(true);
	bt_fond->setDisabled(true);
	bt_screenshot->setDisabled(true);
	bt_supp_zik->setDisabled(true);
	param_diapo->setDisabled(true);
	bt_save_proj->setDisabled(true);
	bt_supprime_diapo->setDisabled(true);
	bt_param_import->setEnabled(true);
	bt_copy_all->setDisabled(true);
	bt_paste_all->setDisabled(true);
	bt_sync->setDisabled(true);
	bt_play->setDisabled(true);
	bt_stop->setDisabled(true);
	bt_start->setDisabled(true);
	bt_end->setDisabled(true);
	group_support->setDisabled(true);
	plane->setChecked(true);
	//
    	lst_transitions->insertItem(0,tr("Pas de transitions"));
	lst_transitions->setItemIcon(0, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/nulltrans.png"));
    	lst_transitions->insertItem(1,tr("Fondu enchaine"));
	lst_transitions->setItemIcon(1, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/crossfade.png"));
    	lst_transitions->insertItem(2,tr("Recouvrement droite"));
	lst_transitions->setItemIcon(2, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/recouvrementdroite.png"));
    	lst_transitions->insertItem(3,tr("Recouvrement gauche"));
	lst_transitions->setItemIcon(3, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/recouvrementgauche.png"));
    	lst_transitions->insertItem(4,tr("Recouvrement haut"));
	lst_transitions->setItemIcon(4, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/recouvrementhaut.png"));
    	lst_transitions->insertItem(5,tr("Recouvrement bas"));
	lst_transitions->setItemIcon(5, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/recouvrementbas.png"));
    	lst_transitions->insertItem(6,tr("Angle haut droit"));
	lst_transitions->setItemIcon(6, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/coinhautdroit.png"));
	lst_transitions->insertItem(7,tr("Angle haut gauche"));
	lst_transitions->setItemIcon(7, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/coinhautgauche.png"));
	lst_transitions->insertItem(8,tr("Angle bas droit"));
	lst_transitions->setItemIcon(8, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/coinbasdroit.png"));
	lst_transitions->insertItem(9,tr("Angle bas gauche"));
	lst_transitions->setItemIcon(9, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/coinbasgauche.png"));
	lst_transitions->insertItem(10,tr("Double horizontal"));
	lst_transitions->setItemIcon(10, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/doubleh.png"));
	lst_transitions->insertItem(11,tr("Double vertical"));
	lst_transitions->setItemIcon(11, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/doublev.png"));
	lst_transitions->insertItem(12,tr("Rideaux horizontaux"));
	lst_transitions->setItemIcon(12, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/rideauh.png"));
	lst_transitions->insertItem(13,tr("Rideaux verticaux"));
	lst_transitions->setItemIcon(13, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/rideauv.png"));
	lst_transitions->insertItem(14,tr("Bandes"));
	lst_transitions->setItemIcon(14, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/bandes.png"));
	lst_transitions->insertItem(15,tr("Spirale"));
	lst_transitions->setItemIcon(15, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/spirale.png"));
	lst_transitions->insertItem(16,tr("Carrelage"));
	lst_transitions->setItemIcon(16, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/carrelage.png"));
	lst_transitions->insertItem(17,tr("Invasion"));
	lst_transitions->setItemIcon(17, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/invasion.png"));
	lst_transitions->insertItem(18,tr("Clock"));
	lst_transitions->setItemIcon(18, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/clock.png"));
	lst_transitions->insertItem(19,tr("Ronds"));
	lst_transitions->setItemIcon(19, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/ronds.png"));
	lst_transitions->insertItem(20,tr("Peinture"));
	lst_transitions->setItemIcon(20, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/peinture.png"));
	lst_transitions->insertItem(21,tr("Cone"));
	lst_transitions->setItemIcon(21, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/cone.png"));
	lst_transitions->insertItem(22,tr("Coulure"));
	lst_transitions->setItemIcon(22, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/coulure.png"));
	lst_transitions->insertItem(23,tr("Tourbillon"));
	lst_transitions->setItemIcon(23, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/tourbillon.png"));
	lst_transitions->insertItem(24,tr("Coeur"));
	lst_transitions->setItemIcon(24, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/coeur.png"));
	//
    	lst_transitions_2->insertItem(0,tr("Pas de transitions"));
	lst_transitions_2->setItemIcon(0, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/nulltrans.png"));
    	lst_transitions_2->insertItem(1,tr("Fondu enchaine"));
	lst_transitions_2->setItemIcon(1, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/crossfade.png"));
    	lst_transitions_2->insertItem(2,tr("Recouvrement droite"));
	lst_transitions_2->setItemIcon(2, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/recouvrementdroite.png"));
    	lst_transitions_2->insertItem(3,tr("Recouvrement gauche"));
	lst_transitions_2->setItemIcon(3, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/recouvrementgauche.png"));
    	lst_transitions_2->insertItem(4,tr("Recouvrement haut"));
	lst_transitions_2->setItemIcon(4, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/recouvrementhaut.png"));
    	lst_transitions_2->insertItem(5,tr("Recouvrement bas"));
	lst_transitions_2->setItemIcon(5, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/recouvrementbas.png"));
	lst_transitions_2->insertItem(6,tr("Angle haut droit"));
	lst_transitions_2->setItemIcon(6, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/coinhautdroit.png"));
	lst_transitions_2->insertItem(7,tr("Angle haut gauche"));
	lst_transitions_2->setItemIcon(7, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/coinhautgauche.png"));
	lst_transitions_2->insertItem(8,tr("Angle bas droit"));
	lst_transitions_2->setItemIcon(8, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/coinbasdroit.png"));
	lst_transitions_2->insertItem(9,tr("Angle bas gauche"));
	lst_transitions_2->setItemIcon(9, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/coinbasgauche.png"));
	lst_transitions_2->insertItem(10,tr("Double horizontal"));
	lst_transitions_2->setItemIcon(10, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/doubleh.png"));
	lst_transitions_2->insertItem(11,tr("Double vertical"));
	lst_transitions_2->setItemIcon(11, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/doublev.png"));
	lst_transitions_2->insertItem(12,tr("Rideaux horizontaux"));
	lst_transitions_2->setItemIcon(12, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/rideauh.png"));
	lst_transitions_2->insertItem(13,tr("Rideaux verticaux"));
	lst_transitions_2->setItemIcon(13, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/rideauv.png"));
	lst_transitions_2->insertItem(14,tr("Bandes"));
	lst_transitions_2->setItemIcon(14, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/bandes.png"));
	lst_transitions_2->insertItem(15,tr("Spirale"));
	lst_transitions_2->setItemIcon(15, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/spirale.png"));
	lst_transitions_2->insertItem(16,tr("Carrelage"));
	lst_transitions_2->setItemIcon(16, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/carrelage.png"));
	lst_transitions_2->insertItem(17,tr("Invasion"));
	lst_transitions_2->setItemIcon(17, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/invasion.png"));
	lst_transitions_2->insertItem(18,tr("Clock"));
	lst_transitions_2->setItemIcon(18, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/clock.png"));
	lst_transitions_2->insertItem(19,tr("Ronds"));
	lst_transitions_2->setItemIcon(19, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/ronds.png"));
	lst_transitions_2->insertItem(20,tr("Peinture"));
	lst_transitions_2->setItemIcon(20, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/peinture.png"));
	lst_transitions_2->insertItem(21,tr("Cone"));
	lst_transitions_2->setItemIcon(21, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/cone.png"));
	lst_transitions_2->insertItem(22,tr("Coulure"));
	lst_transitions_2->setItemIcon(22, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/coulure.png"));
	lst_transitions_2->insertItem(23,tr("Tourbillon"));
	lst_transitions_2->setItemIcon(23, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/tourbillon.png"));
	lst_transitions_2->insertItem(24,tr("Coeur"));
	lst_transitions_2->setItemIcon(24, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/coeur.png"));
	lst_transitions_2->insertItem(25,tr("Aleatoire"));
	lst_transitions_2->setItemIcon(25, QIcon(QApplication::applicationDirPath() + "/Interface/Transitions/random.png"));
	//
	comboposlegende->insertItem(0,tr("Statique bas"));
	comboposlegende->insertItem(1,tr("Statique haut"));
	comboposlegende->insertItem(2,tr("Statique milieu"));
	comboposlegende->insertItem(3,tr("Mouvement bas"));
	//
	comboqualite->insertItem(0,tr("Haute"));
	comboqualite->insertItem(1,tr("Normale"));
	comboqualite->insertItem(2,tr("Basse"));
	comboqualite->insertItem(3,tr("Tres basse"));
	comboqualite->setCurrentIndex(1);
	//
	combocodec->insertItem(0,"MPEG2");
	combocodec->insertItem(1,"Xvid");
	combocodec->insertItem(2,"AVI DV");
	combocodec->setCurrentIndex(0);
	//
	cblangue->insertItem(0,"Francais");
	cblangue->insertItem(1,"English");
	cblangue->insertItem(2,"Catalan");
	cblangue->insertItem(3,"Polish");
	cblangue->insertItem(4,"Russian");
	cblangue->insertItem(5,"Italian");
	cblangue->setCurrentIndex(0);
	//
	comboeffets->insertItem(0,tr("Aucun"));
	comboeffets->setCurrentIndex(0);
	//
	cbplayer->insertItem(0,"xine");
	cbplayer->insertItem(1,"mplayer");
	cbplayer->setCurrentIndex(0);
	//
	list_effets_anim->insertItem(0,tr("Standard"));
	list_effets_anim->insertItem(1,tr("Chute 1"));
	list_effets_anim->insertItem(2,tr("Panoramique horizontal"));
	list_effets_anim->insertItem(3,tr("Panoramique vertical"));
	list_effets_anim->insertItem(4,tr("Toupie"));
	list_effets_anim->insertItem(5,tr("Redresser"));
	list_effets_anim->insertItem(6,tr("Zoom simple"));
	list_effets_anim->setCurrentIndex(0);
	pntmygl->iseffect = 0;
	// ---> Chute
	table_models[0][0] = 0.0f;
	table_models[0][1] = 0.0f;
	table_models[0][2] = -4.0f;
	table_models[0][3] = 0.0f;
	table_models[0][4] = 0.0f;
	table_models[0][5] = 0.0f;
	table_models[0][6] = 0.0f;
	table_models[0][7] = 0.0f;
	table_models[0][8] = -16.9f;
	table_models[0][9] = 0.0f;
	table_models[0][10] = -3.0f;
	table_models[0][11] = 19.0f;
	// ---> Panoramique horizontal
	table_models[1][0] = -1.21f;
	table_models[1][1] = -0.0f;
	table_models[1][2] = -2.1f;
	table_models[1][3] = 0.0f;
	table_models[1][4] = 0.0f;
	table_models[1][5] = 0.0f;
	table_models[1][6] = 1.21f;
	table_models[1][7] = 0.0f;
	table_models[1][8] = -2.1f;
	table_models[1][9] = 0.0f;
	table_models[1][10] = 0.0f;
	table_models[1][11] = 0.0f;
	// ---> Panoramique vertical
	table_models[2][0] = 0.029f;
	table_models[2][1] = -0.96f;
	table_models[2][2] = -2.1f;
	table_models[2][3] = 0.0f;
	table_models[2][4] = 0.0f;
	table_models[2][5] = 0.0f;
	table_models[2][6] = 0.029f;
	table_models[2][7] = 0.96f;
	table_models[2][8] = -2.1f;
	table_models[2][9] = 0.0f;
	table_models[2][10] = 0.0f;
	table_models[2][11] = 0.0f;
	// ---> Toupie
	table_models[3][0] = 0.0f;
	table_models[3][1] = 0.0f;
	table_models[3][2] = -13.7f;
	table_models[3][3] = 0.0f;
	table_models[3][4] = -90.0f;
	table_models[3][5] = 0.0f;
	table_models[3][6] = 0.0f;
	table_models[3][7] = 0.0f;
	table_models[3][8] = -4.0f;
	table_models[3][9] = 0.0f;
	table_models[3][10] = 0.0f;
	table_models[3][11] = 0.0f;
	// ---> Redresser
	table_models[4][0] = -0.04f;
	table_models[4][1] = -0.67f;
	table_models[4][2] = -4.0f;
	table_models[4][3] = -78.0f;
	table_models[4][4] = 0.0f;
	table_models[4][5] = 0.0f;
	table_models[4][6] = 0.0f;
	table_models[4][7] = 0.0f;
	table_models[4][8] = -4.0f;
	table_models[4][9] = 0.0f;
	table_models[4][10] = 0.0f;
	table_models[4][11] = 0.0f;
	// ---> Zoom simple
	table_models[5][0] = 0.0f;
	table_models[5][1] = 0.0f;
	table_models[5][2] = -16.9f;
	table_models[5][3] = 0.0f;
	table_models[5][4] = 0.0f;
	table_models[5][5] = 0.0f;
	table_models[5][6] = 0.0f;
	table_models[5][7] = 0.0f;
	table_models[5][8] = -4.0f;
	table_models[5][9] = 0.0f;
	table_models[5][10] = 0.0f;
	table_models[5][11] = 0.0f;
	//
	nbre_photos = -1;
	current_diapo = -1;
	mygl->setGeometry(10,10,505,388);
	//
	int wl_cpt = 0;
	while ( wl_cpt < 400 )
	{
		table_color_fog[wl_cpt] = QColor(128,128,128);
		wl_cpt = wl_cpt + 1;
	}
	//
	connect(this, SIGNAL(finished( int )),this, SLOT(f_end_mainfrm( int )));
	connect(bt_find_library, SIGNAL(clicked()),this, SLOT(f_path_library()));
	connect(bt_valid_swap, SIGNAL(clicked()),this, SLOT(f_valid_swap()));
	connect(bt_cancel_swap, SIGNAL(clicked()),this, SLOT(f_cancel_swap()));
	connect(bt_swap, SIGNAL(clicked()),this, SLOT(f_swap()));
	connect(plane, SIGNAL(clicked()),this, SLOT(f_plane()));
	connect(flag, SIGNAL(clicked()),this, SLOT(f_flag()));
	connect(cube, SIGNAL(clicked()),this, SLOT(f_cube()));

	connect(bt_ajout_effet, SIGNAL(clicked()),this, SLOT(f_ajout_effet()));
	connect(bt_remove_effet, SIGNAL(clicked()),this, SLOT(f_remove_effet()));
	connect(btcancelextract, SIGNAL(clicked()),this, SLOT(f_cancel_extract()));
	connect(bt_find_video, SIGNAL(clicked()),this, SLOT(f_find_video()));
	connect(btgoextract, SIGNAL(clicked()),this, SLOT(f_go_extract()));
	connect(bt_find_out, SIGNAL(clicked()),this, SLOT(f_find_out()));
	connect(bt_launch_gimp, SIGNAL(clicked()),this, SLOT(f_launch_gimp()));
	connect(bt_remove_photo_2, SIGNAL(clicked()),this, SLOT(supp_diapo()));
	//
	connect(bt_change_color_fog, SIGNAL(clicked()),this, SLOT(f_change_color_fog()));
	connect(bt_debut, SIGNAL(clicked()),this, SLOT(md_start()));
	connect(bt_fin, SIGNAL(clicked()),this, SLOT(md_fin()));
	connect(bt_play, SIGNAL(clicked()),this, SLOT(start_play()));
	connect(bt_stop, SIGNAL(clicked()),this, SLOT(stop_play()));
	connect(bt_start, SIGNAL(clicked()),this, SLOT(sl_go_start()));
	connect(bt_end, SIGNAL(clicked()),this, SLOT(sl_go_end()));
	connect(bt_fond, SIGNAL(clicked()),this, SLOT(f_change_fond()));
	connect(check_fog, SIGNAL(stateChanged(int)),this, SLOT(f_brouillard(int)));
	connect(dial_opacity, SIGNAL(valueChanged(int)),this, SLOT(f_opacity(int)));
	connect(dial_percent_blending, SIGNAL(valueChanged(int)),this, SLOT(f_percent_blending(int)));
	connect(dial_percent_blending_2, SIGNAL(valueChanged(int)),this, SLOT(f_percent_blending_2(int)));

	connect(bt_add_photo, SIGNAL(clicked()),this, SLOT(load_photo()));
	connect(bt_supprime_diapo, SIGNAL(clicked()),this, SLOT(supp_diapo()));
	connect(spindurdiapo, SIGNAL(valueChanged(int)),this, SLOT(f_changedur(int)));
	connect(spindurdiapo_2, SIGNAL(valueChanged(int)),this, SLOT(f_changedur_2(int)));

	connect(effet_hmirror, SIGNAL(clicked()),this, SLOT(f_hmirror()));
	connect(effet_vmirror, SIGNAL(clicked()),this, SLOT(f_vmirror()));
	connect(effet_pcontraste, SIGNAL(clicked()),this, SLOT(f_pcontraste()));
	connect(effet_mcontraste, SIGNAL(clicked()),this, SLOT(f_mcontraste()));
	connect(effet_sepia, SIGNAL(clicked()),this, SLOT(f_sepia()));
	connect(effet_negate, SIGNAL(clicked()),this, SLOT(f_negate()));
	connect(effet_blur, SIGNAL(clicked()),this, SLOT(f_blur()));
	connect(effet_sharpen, SIGNAL(clicked()),this, SLOT(f_sharpen()));
	connect(effet_edge, SIGNAL(clicked()),this, SLOT(f_edge()));
	connect(effet_emboss, SIGNAL(clicked()),this, SLOT(f_emboss()));
	connect(effet_paint, SIGNAL(clicked()),this, SLOT(f_paint()));
	connect(effet_gris, SIGNAL(clicked()),this, SLOT(f_gris()));
	connect(effet_rneg, SIGNAL(clicked()),this, SLOT(f_rneg()));
	connect(effet_rpos, SIGNAL(clicked()),this, SLOT(f_rpos()));
	connect(effet_fade, SIGNAL(clicked()),this, SLOT(f_fade()));

	connect(bt_copy_all, SIGNAL(clicked()),this, SLOT(f_copy()));
	connect(bt_paste_all, SIGNAL(clicked()),this, SLOT(f_paste()));
	connect(bt_raz, SIGNAL(clicked()),this, SLOT(f_raz()));
	connect(bt_close_effets, SIGNAL(clicked()),this, SLOT(f_close_effets()));
	connect(bt_open_comment, SIGNAL(clicked()),this, SLOT(f_open_comment()));

	connect(bt_img_effects, SIGNAL(clicked()),this, SLOT(f_aff_effects()));

	connect(bt_screenshot, SIGNAL(clicked()),this, SLOT(f_screenshot()));
	connect(bt_param_import, SIGNAL(clicked()),this, SLOT(f_affiche_parametres()));
	connect(bt_deplace_image_gauche, SIGNAL(clicked()),this, SLOT(f_dep_gauche()));
	connect(bt_deplace_image_droite, SIGNAL(clicked()),this, SLOT(f_dep_droite()));

	connect(bt_start_encoding, SIGNAL(clicked()),this, SLOT(f_generer_diapo()));

	connect(scroll_timeline, SIGNAL(valueChanged(int)),this, SLOT(f_scroll_timeline(int)));
	connect(lst_transitions, SIGNAL(currentIndexChanged(int)),this, SLOT(f_transition_changed(int)));
	connect(spindurtrans, SIGNAL(valueChanged(int)),this, SLOT(f_transition_duree_changed(int)));
	connect(spindurpausefirst, SIGNAL(valueChanged(int)),this, SLOT(f_durp_deb(int)));
	connect(spindurpauselast, SIGNAL(valueChanged(int)),this, SLOT(f_durp_end(int)));

	connect(comboeffets, SIGNAL(currentIndexChanged(int)),this, SLOT(f_apply_effets(int)));
	connect(comboposlegende, SIGNAL(currentIndexChanged(int)),this, SLOT(f_pos_leg(int)));
	connect(bt_add_zik, SIGNAL(clicked()),this, SLOT(f_add_zik()));
	connect(bt_supp_zik, SIGNAL(clicked()),this, SLOT(f_sup_zik()));
	connect(bt_sync, SIGNAL(clicked()),this, SLOT(f_sync()));

	connect(bt_tool_scale, SIGNAL(clicked()),this, SLOT(f_chg_tool_a()));
	connect(bt_tool_grab, SIGNAL(clicked()),this, SLOT(f_chg_tool_b()));
	connect(bt_tool_rotateX, SIGNAL(clicked()),this, SLOT(f_chg_tool_c()));
	connect(bt_tool_rotateY, SIGNAL(clicked()),this, SLOT(f_chg_tool_d()));
	connect(bt_tool_rotateZ, SIGNAL(clicked()),this, SLOT(f_chg_tool_e()));
	connect(bt_tool_rotateL, SIGNAL(clicked()),this, SLOT(f_chg_tool_f()));

	connect(bt_save_proj, SIGNAL(clicked()),this, SLOT(f_save_proj()));
	connect(bt_open_proj, SIGNAL(clicked()),this, SLOT(f_open_proj()));
	
	connect(bt_police, SIGNAL(clicked()),this, SLOT(f_police()));
	connect(bt_couleur, SIGNAL(clicked()),this, SLOT(f_couleur()));
	connect(legende_image, SIGNAL(textChanged(QString)),this, SLOT(f_chg_leg(QString)));

	connect(&myprocess_1, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(end_process(int, QProcess::ExitStatus)));
	connect(&myprocess_1, SIGNAL(readyReadStandardOutput()), this, SLOT(lecture_console_magick()));
	connect(&myprocess_2, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(end_encoding(int, QProcess::ExitStatus)));
	connect(&myprocess_2, SIGNAL(readyReadStandardError()), this, SLOT(lecture_console_encoding()));
	connect(&myprocess_3, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(end_encoding_audio(int, QProcess::ExitStatus)));
	connect(&myprocess_3, SIGNAL(readyReadStandardError()), this, SLOT(lecture_console_out_audio_encoding()));
	connect(&myprocess_4, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(end_all_audio(int, QProcess::ExitStatus)));
	connect(&myprocess_5, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(end_zik_import(int, QProcess::ExitStatus)));
	connect(&myprocess_5, SIGNAL(readyReadStandardOutput()), this, SLOT(lecture_console_import_zik()));
	connect(&myprocess_7, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(end_convert_video(int, QProcess::ExitStatus)));
	connect(&myprocess_7, SIGNAL(readyReadStandardOutput()), this, SLOT(lecture_convert_video()));
	connect(&myprocess_8, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(end_extract_video(int, QProcess::ExitStatus)));
	connect(&myprocess_8, SIGNAL(readyReadStandardOutput()), this, SLOT(lecture_extract_video()));
	connect(&myprocess_9, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(end_save_project(int, QProcess::ExitStatus)));

	connect(M_BT_PROJ, SIGNAL(clicked()),this, SLOT(f_aff_m_proj()));
	connect(M_BT_IMG, SIGNAL(clicked()),this, SLOT(f_aff_m_img()));
	connect(M_BT_PARAM, SIGNAL(clicked()),this, SLOT(f_aff_m_param()));
	connect(M_BT_EXPORT, SIGNAL(clicked()),this, SLOT(f_aff_m_export()));
	connect(M_BT_ZIK, SIGNAL(clicked()),this, SLOT(f_aff_m_zik()));
	connect(M_BT_3D, SIGNAL(clicked()),this, SLOT(f_aff_m_3d()));

	connect(bt_close_param_import, SIGNAL(clicked()),this, SLOT(f_close_param_import()));
	connect(bt_save_param, SIGNAL(clicked()),this, SLOT(f_save_param_manslide()));
	connect(bt_preview, SIGNAL(clicked()),this, SLOT(f_preview()));
	connect(bt_originale, SIGNAL(clicked()),this, SLOT(f_preview_originale()));
	connect(bt_modifiee, SIGNAL(clicked()),this, SLOT(f_preview_modifiee()));
	connect(bt_start_new, SIGNAL(clicked()),this, SLOT(f_start_new()));

	connect(bt_choix_modele, SIGNAL(clicked()),this, SLOT(f_aff_modele()));
	connect(bt_close_model_anim, SIGNAL(clicked()),this, SLOT(f_close_modele()));
	connect(bt_valid_effet, SIGNAL(clicked()),this, SLOT(f_valide_modele()));
	connect(bt_supp_comment, SIGNAL(clicked()),this, SLOT(f_supp_comment()));
	connect(list_effets_anim, SIGNAL(currentIndexChanged(int)),this, SLOT(f_model_changed(int)));

	// *** FIRST LAUNCH ***
	menu_projet->setDisabled(true);
	frame_topmenu->setDisabled(true);
	contain_timeline->setDisabled(true);
	QDir currentDir = QDir::homePath();
	QFile configfile( currentDir.path() + "/.manslide.cnf" );
	if (configfile.open(QFile::ReadOnly)) 
	{
		QString wtmpvar1;
		QByteArray newData;
		newData = configfile.readLine(0);
		wtmpvar1 = QString::fromLocal8Bit(newData);
		
		if ( wtmpvar1.mid(0,2) == "R2" )
		{
			newData = configfile.readLine(0);
			newData = configfile.readLine(0);
			wtmpvar1 = QString::fromLocal8Bit(newData);
			int myind = wtmpvar1.length();
			wg_player = wtmpvar1.mid(0,myind - 1);
			newData = configfile.readLine(0);
			wtmpvar1 = QString::fromLocal8Bit(newData);
			myind = wtmpvar1.length();
			wg_cpu = wtmpvar1.mid(0,myind - 1);
			newData = configfile.readLine(0);
			wtmpvar1 = QString::fromLocal8Bit(newData);
			myind = wtmpvar1.length();
			wg_library = wtmpvar1.mid(0,myind - 1);
			pntmygl->wg_tet_library = wg_library;
			configfile.close();
			//
			QDir tmpdir(QDir::tempPath() + "/TmpManSlide");
			if ( tmpdir.exists() == false )
			{
				QDir credir(QDir::tempPath());
				if ( credir.mkpath("TmpManSlide") == true )
				{
					wpathprojet = QDir::tempPath() + "/TmpManSlide";
					pntmygl->path_render = wpathprojet;
					bt_save_proj->setDisabled(true);
					bt_add_photo->setEnabled(true);
					bt_supprime_diapo->setDisabled(true);
					bt_param_import->setEnabled(true);
					bt_open_proj->setEnabled(true);
					menu_projet->setEnabled(true);
					frame_topmenu->setEnabled(true);
					contain_timeline->setEnabled(true);
				}
				else
				{
					QMessageBox::information(this, "Manslide", tr("Manslide n a pas reussi a creer un repertoire temporaire dans votre dossier tmp : ") + QDir::tempPath());
				}
			}
			else
			{
				wpathprojet = QDir::tempPath() + "/TmpManSlide";
				pntmygl->path_render = wpathprojet;
				bt_save_proj->setDisabled(true);
				bt_add_photo->setEnabled(true);
				bt_supprime_diapo->setDisabled(true);
				bt_param_import->setEnabled(true);
				bt_open_proj->setEnabled(true);
				menu_projet->setEnabled(true);
				frame_topmenu->setEnabled(true);
				contain_timeline->setEnabled(true);
			}
			//
			tmpdir.setPath(wg_library + "BIB_ManSlide/Effects/");
			QStringList filters;
			filters << "*.*";
			int positem = 1;
			QDir subdir;
			QString wlfile;
			foreach (wlfile, tmpdir.entryList(QDir::Dirs | QDir::NoDotAndDotDot))
			{
				comboeffets->insertItem(positem, wlfile);
				subdir.setPath(wg_library + "/BIB_ManSlide/Effects/" + wlfile);
				pntmygl->table_effets[positem][0] = wlfile;
				pntmygl->table_effets[positem][1] = QString::number(subdir.count());
				positem = positem + 1;
			}
		}
		else
		{
			configfile.close();
			frame_first_time->setGeometry(214,121,571,441);
			frame_first_time->show();
			frame_first_time->raise();
		}
	}
	else
	{
		frame_first_time->setGeometry(214,121,571,441);
		frame_first_time->show();
		frame_first_time->raise();
	}
}

void mainfrm::f_remove_effet()
{
	if ( comboeffets->currentIndex() > -1)
	{
		int result = QMessageBox::information(this, "Manslide", tr("Voulez vous vraiment supprimer cet effet : ") + comboeffets->currentText() , tr("Oui"), tr("Non"), 0, 1 );
		if (result == 0)
		{
			QString thedir(wg_library + "BIB_ManSlide/Effects/" + comboeffets->currentText());
			QString program = "rm";
       			QStringList arguments;
			arguments << "-rf";
			ispreview = 5;
       			arguments << thedir;
       			myprocess_9.start( program, arguments );
		}
	}
}

void mainfrm::f_plane()
{
	table_photos[current_diapo][27] = "0";
	pntmygl->type3D = 0;
	pntmygl->updateGL();
}

void mainfrm::f_flag()
{
	table_photos[current_diapo][27] = "1";
	pntmygl->type3D = 1;
	pntmygl->updateGL();
}

void mainfrm::f_cube()
{
	table_photos[current_diapo][27] = "2";
	pntmygl->type3D = 2;
	pntmygl->updateGL();
}

void mainfrm::f_valid_swap()
{
	must_redraw = 0;
// *** Deplacement images vers droite ***
    	if ( nbre_photos > 0 && dest_diapo->value() != current_diapo + 1)
    	{
        	int cpt1;
        	QLabel *mylabel;
        	QString tmp_tab[1][28];
		QLabel *tmppnt;
        	cpt1 = current_diapo;
        	QColor tmpcolor(0,0,0);

     		mylabel = table_pnt_img[cpt1];
	        //
       		mylabel->setGeometry( (((dest_diapo->value() - 1) * 97) + ((dest_diapo->value() - 1) * 10)) , 0 , 97, 77);
            	// *** Decalage des pointeurs et autres ***
            	tmppnt = table_pnt_img[cpt1];
            	tmp_tab[0][0] = table_photos[cpt1][0];
            	tmp_tab[0][1] = table_photos[cpt1][1];
            	tmp_tab[0][2] = table_photos[cpt1][2];
            	tmp_tab[0][3] = table_photos[cpt1][3];
            	tmp_tab[0][4] = table_photos[cpt1][4];
            	tmp_tab[0][5] = table_photos[cpt1][5];
            	tmp_tab[0][6] = table_photos[cpt1][6];
            	tmp_tab[0][7] = table_photos[cpt1][7];
            	tmp_tab[0][8] = table_photos[cpt1][8];
            	tmp_tab[0][9] = table_photos[cpt1][9];
            	tmp_tab[0][10] = table_photos[cpt1][10];
            	tmp_tab[0][11] = table_photos[cpt1][11];
            	tmp_tab[0][12] = table_photos[cpt1][12];
            	tmp_tab[0][13] = table_photos[cpt1][13];
            	tmp_tab[0][14] = table_photos[cpt1][14];
            	tmp_tab[0][15] = table_photos[cpt1][15];
            	tmp_tab[0][16] = table_photos[cpt1][16];
            	tmp_tab[0][17] = table_photos[cpt1][17];
            	tmp_tab[0][18] = table_photos[cpt1][18];
            	tmp_tab[0][19] = table_photos[cpt1][19];
            	tmp_tab[0][20] = table_photos[cpt1][20];
            	tmp_tab[0][21] = table_photos[cpt1][21];
            	tmp_tab[0][22] = table_photos[cpt1][22];
            	tmp_tab[0][23] = table_photos[cpt1][23];
            	tmp_tab[0][24] = table_photos[cpt1][24];
            	tmp_tab[0][25] = table_photos[cpt1][25];
            	tmp_tab[0][26] = table_photos[cpt1][26];
            	tmp_tab[0][27] = table_photos[cpt1][27];
		tmpcolor = table_color_fog[cpt1];
		//
            	mylabel = table_pnt_img[dest_diapo->value() - 1];
		//
        	mylabel->setGeometry( ((((cpt1) * 97)) + ((cpt1) * 10)), 0 , 97, 77);
            	// *** Decalage des pointeurs et autres ***
            	table_pnt_img[cpt1] = table_pnt_img[dest_diapo->value() - 1];
            	table_photos[cpt1][0] = table_photos[dest_diapo->value() - 1][0];
            	table_photos[cpt1][1] = table_photos[dest_diapo->value() - 1][1];
            	table_photos[cpt1][2] = table_photos[dest_diapo->value() - 1][2];
            	table_photos[cpt1][3] = table_photos[dest_diapo->value() - 1][3];
            	table_photos[cpt1][4] = table_photos[dest_diapo->value() - 1][4];
            	table_photos[cpt1][5] = table_photos[dest_diapo->value() - 1][5];
            	table_photos[cpt1][6] = table_photos[dest_diapo->value() - 1][6];
            	table_photos[cpt1][7] = table_photos[dest_diapo->value() - 1][7];
            	table_photos[cpt1][8] = table_photos[dest_diapo->value() - 1][8];
            	table_photos[cpt1][9] = table_photos[dest_diapo->value() - 1][9];
            	table_photos[cpt1][10] = table_photos[dest_diapo->value() - 1][10];
            	table_photos[cpt1][11] = table_photos[dest_diapo->value() - 1][11];
            	table_photos[cpt1][12] = table_photos[dest_diapo->value() - 1][12];
            	table_photos[cpt1][13] = table_photos[dest_diapo->value() - 1][13];
            	table_photos[cpt1][14] = table_photos[dest_diapo->value() - 1][14];
            	table_photos[cpt1][15] = table_photos[dest_diapo->value() - 1][15];
            	table_photos[cpt1][16] = table_photos[dest_diapo->value() - 1][16];
            	table_photos[cpt1][17] = table_photos[dest_diapo->value() - 1][17];
            	table_photos[cpt1][18] = table_photos[dest_diapo->value() - 1][18];
            	table_photos[cpt1][19] = table_photos[dest_diapo->value() - 1][19];
            	table_photos[cpt1][20] = table_photos[dest_diapo->value() - 1][20];
            	table_photos[cpt1][21] = table_photos[dest_diapo->value() - 1][21];
            	table_photos[cpt1][22] = table_photos[dest_diapo->value() - 1][22];
            	table_photos[cpt1][23] = table_photos[dest_diapo->value() - 1][23];
            	table_photos[cpt1][24] = table_photos[dest_diapo->value() - 1][24];
            	table_photos[cpt1][25] = table_photos[dest_diapo->value() - 1][25];
            	table_photos[cpt1][26] = table_photos[dest_diapo->value() - 1][26];
            	table_photos[cpt1][27] = table_photos[dest_diapo->value() - 1][27];
		table_color_fog[cpt1] = table_color_fog[dest_diapo->value() - 1];
		//
            	table_pnt_img[dest_diapo->value() - 1] = tmppnt;
            	table_photos[dest_diapo->value() - 1][0] = tmp_tab[0][0];
            	table_photos[dest_diapo->value() - 1][1] = tmp_tab[0][1];
            	table_photos[dest_diapo->value() - 1][2] = tmp_tab[0][2];
            	table_photos[dest_diapo->value() - 1][3] = tmp_tab[0][3];
            	table_photos[dest_diapo->value() - 1][4] = tmp_tab[0][4];
            	table_photos[dest_diapo->value() - 1][5] = tmp_tab[0][5];
            	table_photos[dest_diapo->value() - 1][6] = tmp_tab[0][6];
            	table_photos[dest_diapo->value() - 1][7] = tmp_tab[0][7];
            	table_photos[dest_diapo->value() - 1][8] = tmp_tab[0][8];
            	table_photos[dest_diapo->value() - 1][9] = tmp_tab[0][9];
            	table_photos[dest_diapo->value() - 1][10] = tmp_tab[0][10];
            	table_photos[dest_diapo->value() - 1][11] = tmp_tab[0][11];
            	table_photos[dest_diapo->value() - 1][12] = tmp_tab[0][12];
            	table_photos[dest_diapo->value() - 1][13] = tmp_tab[0][13];
            	table_photos[dest_diapo->value() - 1][14] = tmp_tab[0][14];
            	table_photos[dest_diapo->value() - 1][15] = tmp_tab[0][15];
            	table_photos[dest_diapo->value() - 1][16] = tmp_tab[0][16];
            	table_photos[dest_diapo->value() - 1][17] = tmp_tab[0][17];
            	table_photos[dest_diapo->value() - 1][18] = tmp_tab[0][18];
            	table_photos[dest_diapo->value() - 1][19] = tmp_tab[0][19];
            	table_photos[dest_diapo->value() - 1][20] = tmp_tab[0][20];
            	table_photos[dest_diapo->value() - 1][21] = tmp_tab[0][21];
            	table_photos[dest_diapo->value() - 1][22] = tmp_tab[0][22];
            	table_photos[dest_diapo->value() - 1][23] = tmp_tab[0][23];
            	table_photos[dest_diapo->value() - 1][24] = tmp_tab[0][24];
            	table_photos[dest_diapo->value() - 1][25] = tmp_tab[0][25];
            	table_photos[dest_diapo->value() - 1][26] = tmp_tab[0][26];
            	table_photos[dest_diapo->value() - 1][27] = tmp_tab[0][27];
		table_color_fog[dest_diapo->value() - 1] = tmpcolor;
		//
            	affichage_diapo();
        }
	//
	contain_timeline->setEnabled(true);
	frame_toptimeline->setEnabled(true);
	frame_topmenu->setEnabled(true);
	frame_parameters->setEnabled(true);
	menu_projet->setEnabled(true);
	menu_images->setEnabled(true);
	frame_telecomm->setEnabled(true);
	frame_zik->setEnabled(true);
	param_encoding->setEnabled(true);
	bt_start->setEnabled(true);
	bt_stop->setEnabled(true);
	bt_play->setEnabled(true);
	bt_end->setEnabled(true);
	frame_swap->hide();
}

void mainfrm::f_cancel_swap()
{
	contain_timeline->setEnabled(true);
	frame_toptimeline->setEnabled(true);
	frame_topmenu->setEnabled(true);
	frame_parameters->setEnabled(true);
	menu_projet->setEnabled(true);
	menu_images->setEnabled(true);
	frame_telecomm->setEnabled(true);
	frame_zik->setEnabled(true);
	param_encoding->setEnabled(true);
	bt_start->setEnabled(true);
	bt_stop->setEnabled(true);
	bt_play->setEnabled(true);
	bt_end->setEnabled(true);
	frame_swap->hide();
}

void mainfrm::f_swap()
{
	contain_timeline->setDisabled(true);
	frame_toptimeline->setDisabled(true);
	frame_topmenu->setDisabled(true);
	frame_parameters->setDisabled(true);
	menu_projet->setDisabled(true);
	menu_images->setDisabled(true);
	frame_telecomm->setDisabled(true);
	frame_zik->setDisabled(true);
	param_encoding->setDisabled(true);
	bt_start->setDisabled(true);
	bt_stop->setDisabled(true);
	bt_play->setDisabled(true);
	bt_end->setDisabled(true);
	//
	QPixmap wl_pix_001(259,109);
	wl_pix_001.fill(Qt::black);
	QPixmap wl_pix_002 = QPixmap::grabWindow ( this->winId(), 56, 406, 259, 109);
	QPainter p;
	p.begin(&wl_pix_001);
	p.drawPixmap(0, 0, wl_pix_002, 0, 0, -1, -1 );
	p.drawPixmap(0, 0, gl_fond, 0, 0, -1, -1 );
	p.end();
	fond_swap->setPixmap(wl_pix_001);
	fond_swap->setGeometry(1,1,259,109);
	fond_swap->lower();
	//
	label_70->setText(tr("Diapositive ") + QString::number(current_diapo + 1));
	dest_diapo->setMaximum(nbre_photos + 1);
	frame_swap->setGeometry(55,405,261,111);
	frame_swap->show();
	frame_swap->raise();
}

void mainfrm::f_path_library()
{
	QString mydir = QFileDialog::getExistingDirectory( this, tr("Choisissez un repertoire pour la bibliotheque d'effets video"), "~", QFileDialog::ShowDirsOnly | QFileDialog::DontResolveSymlinks);
        if ( mydir.isNull() )
        {
        }
	else
	{
		path_library->setText(mydir);
	}
}

void mainfrm::f_launch_gimp()
{
	QString program = "gimp-remote";
       	QStringList arguments;
	ispreview = 2;
	this->setDisabled(true);
       	arguments << wpathprojet + "/" + table_photos[current_diapo][0];
       	myprocess_9.start( program, arguments );
}

void mainfrm::f_find_out()
{
	QString mydir = QFileDialog::getExistingDirectory( this, tr("Choisissez un repertoire pour le diaporama"), "~", QFileDialog::ShowDirsOnly | QFileDialog::DontResolveSymlinks);
        if ( mydir.isNull() )
        {
        }
	else
	{
		path_out_render->setText(mydir);
	}
}

void mainfrm::f_end_mainfrm(int valeur)
{
	QString program = "rm";
       	QStringList arguments;
	arguments << "-rf";
	ispreview = 9;
       	arguments << QDir::tempPath() + "/TmpManSlide";
       	myprocess_9.start( program, arguments );
}

void mainfrm::f_ajout_effet()
{
	if ( comboeffets->count() < 40 )
	{
		contain_timeline->setDisabled(true);
		frame_toptimeline->setDisabled(true);
		frame_topmenu->setDisabled(true);
		frame_parameters->setDisabled(true);
		btgoextract->setDisabled(true);
		//
		QPixmap wl_pix_001(489,259);
		wl_pix_001.fill(Qt::black);
		QPixmap wl_pix_002 = QPixmap::grabWindow ( this->winId(), 255, 212, 489, 259);
		QPainter p;
		p.begin(&wl_pix_001);
		p.drawPixmap(0, 0, wl_pix_002, 0, 0, -1, -1 );
		p.drawPixmap(0, 0, gl_fond, 0, 0, -1, -1 );
		p.end();
		fond_extract->setPixmap(wl_pix_001);
		fond_extract->setGeometry(1,1,489,259);
		fond_extract->lower();
		//
		pathvideoextract->setText("");
		titreeffet->setText("");
		pbextract->setValue(0);
		frame_extract->setGeometry(254,211,491,261);
		frame_extract->show();
		frame_extract->raise();
	}
	else
	{
		QMessageBox::information(this, "Manslide", tr("Vous avez atteint le nombre maximum d'effet dans la bibliotheque. Supprimez en pour en ajouter de nouveaux."));
	}
}

void mainfrm::f_cancel_extract()
{
	contain_timeline->setEnabled(true);
	frame_toptimeline->setEnabled(true);
	frame_topmenu->setEnabled(true);
	frame_parameters->setEnabled(true);
	frame_extract->hide();
}

void mainfrm::f_find_video()
{
	QString wmyfic = QFileDialog::getOpenFileName(this, tr("Ouvrir une video"), "~", tr("Video (*.mpg *.MPG *.mpeg *.MPEG)"));
        if ( wmyfic.isNull() )
        {
        }
        else
        {
		pathvideoextract->setText(wmyfic);
		btgoextract->setEnabled(true);
	}
}

void mainfrm::f_go_extract()
{
	if ( titreeffet->text() != "" )
	{
		int idxsearch = 1;
		QString nomeffet = titreeffet->text();
		while ( nomeffet != pntmygl->table_effets[idxsearch][0] && idxsearch < 39 )
		{
			idxsearch = idxsearch + 1;
		}
		if ( idxsearch < 39 )
		{
			QMessageBox::information(this, "Manslide", tr("Il existe deja un effet avec le meme nom. Essayez avec un autre nom."));
		}
		else
		{
      			QFile myfic(wpathprojet + "/extract.sh");
		        if ( !myfic.open( QIODevice::WriteOnly ))
        		{
				QMessageBox::information(this, "Manslide", tr("Vous ne disposez pas des droits d ecriture dans ce dossier."));
				return;
			}
			else
			{
				ispreview = duree_extract->value() * 25;
				pbextract->setMaximum(ispreview);
				QString program = "bash";
				QStringList arguments;
				QTextStream out(&myfic);
				out << "#!/bin/bash" << endl;
				out << "mkdir -p " + wg_library + "/BIB_ManSlide/Effects/" + titreeffet->text() << endl;
				out << "cd " + wg_library + "/BIB_ManSlide/Effects/" + titreeffet->text() << endl;
				out << "mplayer -ao null -x 360 -y 288 -vo jpeg:quality=75 -frames " + QString::number(ispreview) + " \"" + pathvideoextract->text() + "\"" << endl;
				out << "rename 00 " + titreeffet->text() + " *.jpg" << endl;
				out << "exit" << endl;
				myfic.close();
				arguments << wpathprojet + "/extract.sh";
       				myprocess_8.start( program, arguments );
				frame_extract->setDisabled(true);
			}
		}
	}
	else
	{
		QMessageBox::information(this, "Manslide", tr("Vous devez choisir un nom pour votre effet."));
	}
}

void mainfrm::lecture_extract_video()
{
	QByteArray newData = myprocess_8.readAllStandardOutput();
	QString wl_var_1 = QString::fromLocal8Bit(newData);
       	int j = wl_var_1.indexOf("A:", 0);
        if ( j != -1 )
        {
		poursuite = poursuite + 1;
		pbextract->setValue(poursuite);
        }
}

void mainfrm::end_extract_video(int, QProcess::ExitStatus)
{
	frame_extract->setEnabled(true);
	contain_timeline->setEnabled(true);
	frame_toptimeline->setEnabled(true);
	frame_topmenu->setEnabled(true);
	frame_parameters->setEnabled(true);
	frame_extract->hide();
	//
	QString nomeffet = titreeffet->text();
	comboeffets->clear();
	comboeffets->insertItem(0,tr("Aucun"));
	QDir wcurrentDir(wg_library + "/BIB_ManSlide/Effects/");
	QStringList filters;
	filters << "*.*";
	int positem = 1;
	QDir subdir;

	foreach (QString file, wcurrentDir.entryList(QDir::Dirs | QDir::NoDotAndDotDot))
	{
		comboeffets->insertItem(positem, file);
		subdir.setPath(wg_library + "/BIB_ManSlide/Effects/" + file);
		pntmygl->table_effets[positem][0] = file;
		pntmygl->table_effets[positem][1] = QString::number(subdir.count());
		positem = positem + 1;
	}
	//
	int idxsearch = 1;
	
	while ( nomeffet != pntmygl->table_effets[idxsearch][0] && idxsearch < 39 )
	{
		idxsearch = idxsearch + 1;
	}
	if ( idxsearch < 39 )
	{
		comboeffets->setCurrentIndex(idxsearch);
		pntmygl->iseffect = idxsearch;
		table_photos[current_diapo][22] = nomeffet;
		pntmygl->load_effet(idxsearch,nomeffet);
	}
	else
	{
		QMessageBox::information(this, "Manslide", tr("L extraction a echouee pour une raison inconnue. Avez vous mplayer correctement installe ?"));
	}
}

void mainfrm::sl_go_start()
{
	position_flux = 0;
	pntmygl->wg_percent = table_photos[current_diapo][25].toFloat() / 100;
	pntmygl->sl_go_start();
	pntmygl->updateGL();
}

void mainfrm::sl_go_end()
{
	position_flux = 1;
	pntmygl->wg_percent = table_photos[current_diapo][26].toFloat() / 100;
	pntmygl->sl_go_end();
	pntmygl->updateGL();
}

void mainfrm::f_start_new()
{
	int destruct_i_1 = 0;
	while ( destruct_i_1 <= nbre_photos && destruct_i_1 < 400 )
	{
		delete table_pnt_img[destruct_i_1];
		table_color_fog[destruct_i_1] = QColor(128,128,128);
		destruct_i_1 = destruct_i_1 + 1;
	}
	QDir wcurrentDir(wpathprojet);
	QStringList filters;
	filters << "*.*";
	QString wl_tmp_1;

	foreach (QString file, wcurrentDir.entryList(QDir::Files))
	{
		wl_tmp_1 = wpathprojet + "/" + file;
		if ( QFile::remove ( wl_tmp_1 ) == false )
		{
			qDebug() << "ERROR REMOVING FILE FROM TMP DIRECTORY ...";
		}
	}
	lcdlength->display(0);
	pntmygl->initializeGL();
	pntmygl->sl_charge_image(QApplication::applicationDirPath() + "$N$U$L$L",QApplication::applicationDirPath() + "$N$U$L$L");
	pntmygl->updateGL();
	pntmygl->txt_sur_image = "";
	pntmygl->tool = 0;
	pntmygl->effet_titre = 0;
	pntmygl->x_titre = -1.8;
	pntmygl->v_titre = 1;
	frame_ed3d->setDisabled(true);
	path_photos_import = "~";
	pntmygl->mycolor.setRgb(255,255,255);
	zik_number = 0;
	zik_1->hide();
	total_audio = 0;
	must_redraw = 0;
	stick_menu->setGeometry(10,7,98,32);
	M_BT_PROJ->setDisabled(true);
	M_BT_PROJ->raise();
	group_support->setDisabled(true);
	frame_toptimeline->setDisabled(true);
	contain_timeline->setDisabled(true);
	frame_fade->setDisabled(true);
	img_selection->hide();
	bt_img_effects->setDisabled(true);
	bt_start_new->setDisabled(true);
	bt_fond->setDisabled(true);
	bt_screenshot->setDisabled(true);
	bt_supp_zik->setDisabled(true);
	param_diapo->setDisabled(true);
	bt_save_proj->setDisabled(true);
	bt_supprime_diapo->setDisabled(true);
	bt_param_import->setEnabled(true);
	bt_copy_all->setDisabled(true);
	bt_paste_all->setDisabled(true);
	bt_sync->setDisabled(true);
	bt_play->setDisabled(true);
	bt_stop->setDisabled(true);
	bt_start->setDisabled(true);
	bt_end->setDisabled(true);
	M_BT_PROJ->setEnabled(true);
	M_BT_IMG->setEnabled(true);
	M_BT_PARAM->setDisabled(true);
	M_BT_EXPORT->setDisabled(true);
	M_BT_ZIK->setDisabled(true);
	M_BT_3D->setDisabled(true);
	nbre_photos = -1;
	current_diapo = -1;
}

void mainfrm::f_change_color_fog()
{
        table_color_fog[current_diapo] = QColorDialog::getColor(table_color_fog[current_diapo], this);
        if (table_color_fog[current_diapo].isValid())
	{
		pntmygl->fogcolor[0] = (float)table_color_fog[current_diapo].red() / (float)255;
		pntmygl->fogcolor[1] = (float)table_color_fog[current_diapo].green() / (float)255;
		pntmygl->fogcolor[2] = (float)table_color_fog[current_diapo].blue() / (float)255;
		pntmygl->fogcolor[3] = 0.5;
		if ( table_photos[current_diapo][14] == "1" )
		{
			pntmygl->change_fog_color();
			pntmygl->updateGL();
		}
        }
}

void mainfrm::f_changedur_2(int valeur)
{
	spindurtrans_2->setMaximum(valeur);
}

void mainfrm::f_supp_comment()
{
	title_comment->setText("");
	table_photos[current_diapo][24] = "";
	//
	QLabel *mylabel;
	mylabel = table_pnt_img[current_diapo];
	QPixmap wl_pix_1(table_photos[current_diapo][0]);
	QPixmap wl_pix_2(wg_diapositive);
	QPixmap wl_pix_3(83,63);
	if ( wl_pix_1.height() > wl_pix_1.width() )
	{
		wl_pix_3 = wl_pix_1.scaledToHeight ( 63, Qt::FastTransformation );
	}
	else
	{
		wl_pix_3 = wl_pix_1.scaledToWidth ( 83, Qt::FastTransformation );
	}
	QPainter p;
	p.begin(&wl_pix_2);
	p.drawPixmap(7 + ((83 - wl_pix_3.width()) / 2), 7, wl_pix_3, 0, 0, 83, 63 );
	QIcon myicon = lst_transitions->itemIcon(lst_transitions->currentIndex());
	myicon.paint ( &p, 56, 45, 32, 24, Qt::AlignCenter, QIcon::Normal, QIcon::On );
	p.end();
	mylabel->setPixmap(wl_pix_2);
}

void mainfrm::f_model_changed(int mymodel)
{
	pntmygl->sl_stop();
	//
	if ( mymodel > 0 )
	{
		pntmygl->debut_px = table_models[mymodel - 1][0];
		pntmygl->debut_py = table_models[mymodel - 1][1];
		pntmygl->debut_pz = table_models[mymodel - 1][2];
		pntmygl->debut_rx = table_models[mymodel - 1][3];
		pntmygl->debut_ry = table_models[mymodel - 1][4];
		pntmygl->debut_rz = table_models[mymodel - 1][5];
		//
		pntmygl->fin_px = table_models[mymodel - 1][6];
		pntmygl->fin_py = table_models[mymodel - 1][7];
		pntmygl->fin_pz = table_models[mymodel - 1][8];
		pntmygl->fin_rx = table_models[mymodel - 1][9];
		pntmygl->fin_ry = table_models[mymodel - 1][10];
		pntmygl->fin_rz = table_models[mymodel - 1][11];
		//
		pntmygl->sl_play();
	}
	//
}

void mainfrm::f_aff_modele()
{
	//
	QPixmap wl_pix_001(419,239);
	wl_pix_001.fill(Qt::black);
	QPixmap wl_pix_002 = QPixmap::grabWindow ( this->winId(), 9, 151, 419, 239);
	QPainter p;
	p.begin(&wl_pix_001);
	p.drawPixmap(0, 0, wl_pix_002, 0, 0, -1, -1 );
	p.drawPixmap(0, 0, gl_fond, 0, 0, -1, -1 );
	p.end();
	fond_effet->setPixmap(wl_pix_001);
	fond_effet->setGeometry(1,1,419,239);
	fond_effet->lower();
	//
	list_effets_anim->setCurrentIndex(0);
	bt_play->setDisabled(true);
	bt_start->setDisabled(true);
	bt_end->setDisabled(true);
	frame_toptimeline->setDisabled(true);
	//
	frame_topmenu->setDisabled(true);
	frame_telecomm->setDisabled(true);
	contain_timeline->setDisabled(true);
	//
	frame_effet_anim->setGeometry(8,150,421,241);
	frame_effet_anim->show();
	frame_effet_anim->raise();
}

void mainfrm::f_close_modele()
{
	pntmygl->sl_stop();
	affichage_diapo();
	//
	bt_play->setEnabled(true);
	bt_start->setEnabled(true);
	bt_end->setEnabled(true);
	frame_toptimeline->setEnabled(true);
	//
	frame_topmenu->setEnabled(true);
	frame_telecomm->setEnabled(true);
	contain_timeline->setEnabled(true);
	//
	frame_effet_anim->hide();
}

void mainfrm::f_valide_modele()
{
	pntmygl->sl_stop();
	//
	if ( list_effets_anim->currentIndex() > 0 )
	{
       		table_photos[current_diapo][1] = QString::number(table_models[list_effets_anim->currentIndex()-1][0]);
       		table_photos[current_diapo][2] = QString::number(table_models[list_effets_anim->currentIndex()-1][1]);
       		table_photos[current_diapo][3] = QString::number(table_models[list_effets_anim->currentIndex()-1][2]);
       		table_photos[current_diapo][4] = QString::number(table_models[list_effets_anim->currentIndex()-1][3]);
       		table_photos[current_diapo][5] = QString::number(table_models[list_effets_anim->currentIndex()-1][4]);
       		table_photos[current_diapo][6] = QString::number(table_models[list_effets_anim->currentIndex()-1][5]);
		//
       		table_photos[current_diapo][7] = QString::number(table_models[list_effets_anim->currentIndex()-1][6]);
       		table_photos[current_diapo][8] = QString::number(table_models[list_effets_anim->currentIndex()-1][7]);
       		table_photos[current_diapo][9] = QString::number(table_models[list_effets_anim->currentIndex()-1][8]);
       		table_photos[current_diapo][10] = QString::number(table_models[list_effets_anim->currentIndex()-1][9]);
       		table_photos[current_diapo][11] = QString::number(table_models[list_effets_anim->currentIndex()-1][10]);
       		table_photos[current_diapo][12] = QString::number(table_models[list_effets_anim->currentIndex()-1][11]);
		pntmygl->updateGL();
	}
	else
	{
       		pntmygl->debut_px = table_photos[current_diapo][0].toFloat();
       		pntmygl->debut_py = table_photos[current_diapo][1].toFloat();
       		pntmygl->debut_pz = table_photos[current_diapo][2].toFloat();
       		pntmygl->debut_rx = table_photos[current_diapo][3].toFloat();
       		pntmygl->debut_ry = table_photos[current_diapo][4].toFloat();
       		pntmygl->debut_rz = table_photos[current_diapo][5].toFloat();
		//
       		pntmygl->fin_px = table_photos[current_diapo][6].toFloat();
       		pntmygl->fin_px = table_photos[current_diapo][7].toFloat();
       		pntmygl->fin_px = table_photos[current_diapo][8].toFloat();
       		pntmygl->fin_px = table_photos[current_diapo][9].toFloat();
       		pntmygl->fin_px = table_photos[current_diapo][10].toFloat();
       		pntmygl->fin_px = table_photos[current_diapo][11].toFloat();
		//
		pntmygl->deplacementX = pntmygl->debut_px;
		pntmygl->deplacementY = pntmygl->debut_py;
		pntmygl->zoom = pntmygl->debut_pz;
		pntmygl->rotationX = pntmygl->debut_rx;
		pntmygl->rotationY = pntmygl->debut_ry;
		pntmygl->rotationZ = pntmygl->debut_rz;
		pntmygl->updateGL();
	}
	//
	bt_play->setEnabled(true);
	bt_start->setEnabled(true);
	bt_end->setEnabled(true);
	frame_toptimeline->setEnabled(true);
	//
	frame_topmenu->setEnabled(true);
	frame_telecomm->setEnabled(true);
	contain_timeline->setEnabled(true);
	//
	affichage_diapo();
	frame_effet_anim->hide();
}

void mainfrm::f_preview()
{
	ispreview = 1;
	this->setDisabled(true);
	frame_ed3d->setGeometry(130,44,740,596);
	pntmygl->setGeometry(10,10,720,576);
	frame_ed3d->raise();
	QTimer::singleShot(150, this, SLOT(f_render()));
}

void mainfrm::f_save_param_manslide()
{
	if ( path_library->text() != "" )
	{
		QDir currentDir = QDir::homePath();
		QFile configfile( currentDir.path() + "/.manslide.cnf" );
		if (configfile.open(QIODevice::WriteOnly)) 
		{
			QTextStream out(&configfile);
			out << "R2" << endl;
			out << cblangue->currentText() << endl;
			out << cbplayer->currentText() << endl;
			out << QString::number(cpunumber->value()) << endl;
			out << path_library->text() << endl;
			configfile.close();
			if ( cblangue->currentText() == "Francais" )
			{
				QMessageBox::information(this, "Manslide", "L'application va se fermer. Relancez la pour prendre en compte vos parametres.");
			}
			else
			{
				QMessageBox::information(this, "Manslide", "Application will be close. Please restart for apply your parameters.");
			}
			// *** Creation de la bibliotheque ***
			QDir tmpdir(path_library->text());
			if ( tmpdir.exists() == true )
			{
				if ( tmpdir.mkpath("BIB_ManSlide") == true )
				{
					QString program = "cp";
       					QStringList arguments;
					ispreview = 4;
					arguments << "-r";
       					arguments << QApplication::applicationDirPath() + "/Effects/";
       					arguments << path_library->text() + "/BIB_ManSlide/";
       					myprocess_9.start( program, arguments );
				}
				else
				{
					QMessageBox::information(this, "Manslide", tr("Impossible de creer le dossier de la bibliotheque. Disposez vous des droits d'ecriture dans ce dossier ...") + path_library->text());
				}
			}
			else
			{
				QMessageBox::information(this, "Manslide", tr("Le dossier n'existe pas ou plus ... ") + path_library->text());
			}
		}
		else
		{
			QMessageBox::information(this, "Manslide", tr("Impossible de creer le fichier de configuration. Disposez vous des droits d'ecriture dans ce dossier ...") + currentDir.dirName());
			this->close();
		}
	}
	else
	{
		QMessageBox::information(this, "Manslide", tr("Vous devez choisir le dossier qui contiendra les effets video. Assurez vous d'avoir les droits d'ecriture dans ce dossier."));
	}
}

void mainfrm::f_aff_m_proj()
{
	stick_menu->setGeometry(10,7,98,32);
	frame_effets->hide();
	M_BT_PROJ->setDisabled(true);
	M_BT_PROJ->raise();
	M_BT_IMG->setEnabled(true);
	M_BT_PARAM->setEnabled(true);
	M_BT_EXPORT->setEnabled(true);
	M_BT_ZIK->setEnabled(true);
	M_BT_3D->setEnabled(true);
	if ( nbre_photos > 0 )
	{
		frame_toptimeline->setEnabled(true);
	}
	menu_projet->setGeometry(0,50,391,471);
	menu_projet->show();
	menu_images->hide();
	frame_telecomm->hide();
	frame_zik->hide();
	frame_parameters->hide();
	param_encoding->hide();
	menu_projet->setFocus();
}

void mainfrm::f_aff_m_img()
{
	stick_menu->setGeometry(106,7,98,32);
	frame_effets->hide();
	M_BT_PROJ->setEnabled(true);
	M_BT_IMG->setDisabled(true);
	M_BT_IMG->raise();
	M_BT_PARAM->setEnabled(true);
	M_BT_EXPORT->setEnabled(true);
	M_BT_ZIK->setEnabled(true);
	M_BT_3D->setEnabled(true);
	if ( nbre_photos >= 0 )
	{
		frame_toptimeline->setEnabled(true);
	}
	menu_projet->hide();
	frame_zik->hide();
	frame_telecomm->hide();
	menu_images->setGeometry(0,50,411,471);
	menu_images->show();
	frame_parameters->hide();
	param_encoding->hide();
	bt_add_photo->setFocus();
}

void mainfrm::f_aff_m_param()
{
    	if ( nbre_photos >= 0 )
    	{
		stick_menu->setGeometry(206,7,98,32);
		frame_effets->hide();
		M_BT_PROJ->setEnabled(true);
		M_BT_IMG->setEnabled(true);
		M_BT_PARAM->setDisabled(true);
		M_BT_PARAM->raise();
		M_BT_EXPORT->setEnabled(true);
		M_BT_ZIK->setEnabled(true);
		M_BT_3D->setEnabled(true);
		frame_toptimeline->setEnabled(true);
		menu_projet->hide();
		menu_images->hide();
		frame_zik->hide();
		frame_telecomm->hide();
		frame_parameters->setGeometry(0,50,391,471);
		frame_parameters->show();
		param_encoding->hide();
	}
	lst_transitions->setFocus();
}

void mainfrm::f_aff_m_export()
{
    	if ( nbre_photos >= 0 )
    	{
		stick_menu->setGeometry(895,7,98,32);
		frame_effets->hide();
		M_BT_PROJ->setEnabled(true);
		M_BT_IMG->setEnabled(true);
		M_BT_PARAM->setEnabled(true);
		M_BT_EXPORT->setDisabled(true);
		M_BT_ZIK->setEnabled(true);
		M_BT_3D->setEnabled(true);
		M_BT_EXPORT->raise();
		from_encoding->setMaximum(nbre_photos + 1);
		from_encoding->setMinimum(1);
		to_encoding->setMaximum(nbre_photos + 1);
		to_encoding->setValue(nbre_photos + 1);
		to_encoding->setMinimum(1);
		param_encoding->setGeometry(0,50,391,471);
		menu_projet->hide();
		menu_images->hide();
		frame_toptimeline->setDisabled(true);
		frame_telecomm->hide();
		frame_parameters->hide();
		frame_zik->hide();
		param_encoding->show();
	}
	from_encoding->setFocus();
}

void mainfrm::f_aff_m_zik()
{
    	if ( nbre_photos >= 0 )
    	{
		stick_menu->setGeometry(305,7,98,32);
		frame_effets->hide();
		M_BT_PROJ->setEnabled(true);
		M_BT_IMG->setEnabled(true);
		M_BT_PARAM->setEnabled(true);
		M_BT_EXPORT->setEnabled(true);
		M_BT_3D->setEnabled(true);
		M_BT_ZIK->setDisabled(true);
		M_BT_ZIK->raise();
		menu_projet->hide();
		menu_images->hide();
		frame_toptimeline->setEnabled(true);
		frame_telecomm->hide();
		frame_parameters->hide();
		frame_zik->setGeometry(0,50,391,471);
		frame_zik->show();
		param_encoding->hide();
	}
	lst_transitions->setFocus();
}

void mainfrm::f_aff_m_3d()
{
    	if ( nbre_photos >= 0 )
    	{
		stick_menu->setGeometry(405,7,98,32);
		frame_effets->hide();
		M_BT_PROJ->setEnabled(true);
		M_BT_IMG->setEnabled(true);
		M_BT_PARAM->setEnabled(true);
		M_BT_EXPORT->setEnabled(true);
		M_BT_ZIK->setEnabled(true);
		M_BT_3D->setDisabled(true);
		M_BT_3D->raise();
		frame_toptimeline->setEnabled(true);
		menu_projet->hide();
		menu_images->hide();
		frame_parameters->hide();
		frame_zik->hide();
		frame_telecomm->setGeometry(0,50,391,471);
		frame_telecomm->show();
		param_encoding->hide();
	}
	lst_transitions->setFocus();
}

void mainfrm::f_open_comment()
{
	QString wmyfic = QFileDialog::getOpenFileName(this, tr("Ouvrir un fichier audio"), "~", tr("Audio (*.ogg *.OGG)"));
        if ( wmyfic.isNull() )
        {
        }
        else
        {
		int tmpvar2 = wmyfic.lastIndexOf("/");
		QFile::copy ( wmyfic, wpathprojet + "/" + wmyfic.mid(tmpvar2 + 1,wmyfic.length() - (tmpvar2+1)) );
		title_comment->setText(wmyfic);
		table_photos[current_diapo][24] = wmyfic.mid(tmpvar2 + 1,wmyfic.length() - (tmpvar2+1));
		//
		QLabel *mylabel;
		mylabel = table_pnt_img[current_diapo];
		QPixmap wl_pix_1(wpathprojet + "/" + table_photos[current_diapo][0]);
		QPixmap wl_pix_2(wg_diapositive);
		QPixmap wl_pix_3(83,63);
		if ( wl_pix_1.height() > wl_pix_1.width() )
		{
			wl_pix_3 = wl_pix_1.scaledToHeight ( 63, Qt::FastTransformation );
		}
		else
		{
			wl_pix_3 = wl_pix_1.scaledToWidth ( 83, Qt::FastTransformation );
		}
		QPainter p;
		p.begin(&wl_pix_2);
		p.drawPixmap(7 + ((83 - wl_pix_3.width()) / 2), 7, wl_pix_3, 0, 0, 83, 63 );
		p.drawPixmap(2, 57, wg_comment, 0, 0, -1, -1 );
		QIcon myicon = lst_transitions->itemIcon(lst_transitions->currentIndex());
		myicon.paint ( &p, 56, 45, 32, 24, Qt::AlignCenter, QIcon::Normal, QIcon::On );
		p.end();
		mylabel->setPixmap(wl_pix_2);
	}
}

void mainfrm::f_close_effets()
{
	frame_effets->hide();
	bt_play->setEnabled(true);
	bt_start->setEnabled(true);
	bt_end->setEnabled(true);
	frame_toptimeline->setEnabled(true);
	//
	frame_topmenu->setEnabled(true);
	menu_images->setEnabled(true);
	contain_timeline->setEnabled(true);
}

void mainfrm::f_aff_effects()
{
	bt_play->setDisabled(true);
	bt_start->setDisabled(true);
	bt_end->setDisabled(true);
	frame_toptimeline->setDisabled(true);
	//
	frame_topmenu->setDisabled(true);
	menu_images->setDisabled(true);
	contain_timeline->setDisabled(true);
	//
	frame_effets->setGeometry(219,165,562,351);
	frame_effets->show();
	frame_effets->raise();
}

void mainfrm::f_save_proj()
{
	QString wmyfic = QFileDialog::getSaveFileName(this, tr("Sauvegarder votre projet"), "~", tr("Projet (*.msz *.MSZ)"));
        if ( wmyfic.isNull() )
        {
        }
        else
        {
		if ( wmyfic.right(4) != ".msz" && wmyfic.right(4) != ".MSZ" )
		{
			wmyfic = wmyfic + ".msz";
		}
        	QFile myfic(wpathprojet + "/projet.gib");

        	if ( !myfic.open( QIODevice::WriteOnly ))
        	{
			QMessageBox::information(this, "Manslide", tr("Erreur lors de la sauvegarde du projet"));
			return;
		}
		else
		{
			QTextStream out(&myfic);
			int i = 0;
			int n = 0;
			ispreview = 1;
			//
			out << "V5" << endl;
			out << pntmygl->mycolor.red() << endl;
			out << pntmygl->mycolor.green() << endl;
			out << pntmygl->mycolor.blue() << endl;
			out << pntmygl->myfont.toString() << endl;
			out << "AUDIO:" << table_zik[0][0] << endl;
			out << "AUDIOLENGTH:" << table_zik[0][1] << endl;
			//
			while ( i <= nbre_photos )
			{
				n = 0;
				while ( n < 28 )
				{
					out << table_photos[i][n] << endl;
					n = n + 1;
				}
				out << table_color_fog[i].red() << endl;
				out << table_color_fog[i].green() << endl;
				out << table_color_fog[i].blue() << endl;
				i = i + 1;
			}
			myfic.close();
        		QFile myfic2(QDir::tempPath() + "/save.sh");

        		if ( !myfic2.open( QIODevice::WriteOnly ))
        		{
				QMessageBox::information(this, "Manslide", tr("Erreur lors de la sauvegarde du projet"));
				return;
			}
			else
			{
				QTextStream out2(&myfic2);
				//
				out2 << "#!/bin/bash" << endl;
				out2 << "cd " << QDir::tempPath() << endl;
				out2 << "tar -cf " << wmyfic << " TmpManSlide" << endl;
				out2 << "rm -f save.sh" << endl;
				myfic2.close();
				QString program = "bash";
       				QStringList arguments;
       				arguments << QDir::tempPath() + "/save.sh";
       				myprocess_9.start( program, arguments );
			}
		}
	}
}

void mainfrm::end_save_project(int, QProcess::ExitStatus)
{
	if ( ispreview == 1 )
	{
		QMessageBox::information(this, "Manslide", tr("Sauvegarde du projet terminee."));
	}
	else
	{
		if ( ispreview == 0 )
		{
			int destruct_i_1 = 0;
			while ( destruct_i_1 <= nbre_photos && destruct_i_1 < 400 )
			{
				delete table_pnt_img[destruct_i_1];
				table_color_fog[destruct_i_1] = QColor(128,128,128);
				destruct_i_1 = destruct_i_1 + 1;
			}
        		QFile myfic(wpathprojet + "/projet.gib");
			QByteArray newData;
			QString wl_var_1;
			int tmp_num_001;
			zik_number = 0;
			zik_1->hide();
        		if ( !myfic.open( QIODevice::ReadOnly ))
        		{
				QMessageBox::information(this, "Manslide", tr("Erreur lors de l'ouverture du projet"));
				return;
			}
			else
			{
				newData = myfic.readLine(0);
				wl_var_1 = QString::fromLocal8Bit(newData);
				int nbreoccur = 27;
				if ( wl_var_1.mid(0,2) == "V5" )
				{
					nbreoccur = 28;
				}
				newData = myfic.readLine(0);
				wl_var_1 = QString::fromLocal8Bit(newData);

				// *** Rouge ***
				tmp_num_001 = wl_var_1.mid(0, newData.count() - 1).toInt();
				pntmygl->mycolor.setRed( tmp_num_001 );
			
				// *** Vert ***
				newData = myfic.readLine(0);
				wl_var_1 = QString::fromLocal8Bit(newData);
				tmp_num_001 = wl_var_1.mid(0, newData.count() - 1).toInt();
				pntmygl->mycolor.setGreen( tmp_num_001 );

				// *** Bleu ***
				newData = myfic.readLine(0);
				wl_var_1 = QString::fromLocal8Bit(newData);
				tmp_num_001 = wl_var_1.mid(0, newData.count() - 1).toInt();
				pntmygl->mycolor.setBlue( tmp_num_001 );

				// *** Police ***
				newData = myfic.readLine(0);
				wl_var_1 = QString::fromLocal8Bit(newData);
				pntmygl->myfont.fromString(wl_var_1);

				// *** Musique pathname ***
				newData = myfic.readLine(0);
				wl_var_1 = QString::fromLocal8Bit(newData);
				if ( wl_var_1.length() > 7 )
				{
					table_zik[0][0] = wl_var_1.mid(6,wl_var_1.length() - 7);
					zik_number = 1;
				}

				// *** Musique duree ***
				newData = myfic.readLine(0);
				wl_var_1 = QString::fromLocal8Bit(newData);
				if ( wl_var_1.length() > 12 )
				{
					table_zik[0][1] = wl_var_1.mid(12,wl_var_1.length() - 13);
				}

				// *** Photos ***
				int i = 0;
				int j = 0;
				QPixmap wl_pix_1;
				QPixmap wl_pix_2(97,77);
				QPixmap wl_pix_3(83,63);
				QPainter p;
				QIcon myicon;
				QColor wl_mycolor;

				newData = myfic.readLine(0);
				while ( myfic.atEnd() == false )
				{
					j = 0;
					while ( j < nbreoccur )
					{
						wl_var_1 = QString::fromLocal8Bit(newData);
						table_photos[i][j] = wl_var_1.mid(0,wl_var_1.length() - 1);
						j = j + 1;
						newData = myfic.readLine(0);
					}
					if ( nbreoccur == 27 )
					{
						table_photos[i][28] = "0";
					}
					// *** Rouge ***
					wl_var_1 = QString::fromLocal8Bit(newData);
					tmp_num_001 = wl_var_1.mid(0, newData.count() - 1).toInt();
					wl_mycolor.setRed( tmp_num_001 );
			
					// *** Vert ***
					newData = myfic.readLine(0);
					wl_var_1 = QString::fromLocal8Bit(newData);
					tmp_num_001 = wl_var_1.mid(0, newData.count() - 1).toInt();
					wl_mycolor.setGreen( tmp_num_001 );

					// *** Bleu ***
					newData = myfic.readLine(0);
					wl_var_1 = QString::fromLocal8Bit(newData);
					tmp_num_001 = wl_var_1.mid(0, newData.count() - 1).toInt();
					wl_mycolor.setBlue( tmp_num_001 );
					table_color_fog[i] = wl_mycolor;
					newData = myfic.readLine(0);

					myicon = lst_transitions_2->itemIcon(table_photos[i][20].toInt());
					if ( wl_pix_1.load( wpathprojet + "/" + table_photos[i][0]) == true )
					{
						wl_pix_2 = wg_diapositive;
						if ( wl_pix_1.height() > wl_pix_1.width() )
						{
							wl_pix_3 = wl_pix_1.scaledToHeight ( 63, Qt::FastTransformation );
						}
						else
						{
							wl_pix_3 = wl_pix_1.scaledToWidth ( 83, Qt::FastTransformation );
						}
        					p.begin(&wl_pix_2);
						p.drawPixmap(7 + ((83 - wl_pix_3.width()) / 2), 7 + ((63 - wl_pix_3.height()) / 2), wl_pix_3, 0, 0, 83, 63 );
						myicon.paint ( &p, 56, 45, 32, 24, Qt::AlignCenter, QIcon::Normal, QIcon::On );
						if ( table_photos[i][24] != "" )
						{
							p.drawPixmap(2, 57, wg_comment, 0, 0, -1, -1 );
						}
						p.end();
						//
						img_selection->show();
        					QLabel *mylabel = new QLabel(timeline);
						mylabel->installEventFilter(this);
						table_pnt_img[i] = mylabel;
        					mylabel->setGeometry( ((i * 97) + (i * 10)), 0, 97, 77);
						img_selection->setGeometry( ((i * 97) + (i * 10)), 0, 97, 77);
						img_selection->raise();
        					mylabel->setPixmap ( wl_pix_2 );
        					mylabel->show();
						//
						i = i + 1;
					}
				}
				nbre_photos = i - 1;
				current_diapo = 0;
				//
				if ( ((nbre_photos + 1) * 110) - 740 > 0 )
				{
					scroll_timeline->setMaximum(((nbre_photos + 1) * 110) - 740);
				}
				if ( i > 0 )
				{
					bt_start_new->setEnabled(true);
					bt_save_proj->setEnabled(true);
					bt_supprime_diapo->setEnabled(true);
					frame_ed3d->setEnabled(true);
					bt_copy_all->setEnabled(true);
					bt_play->setEnabled(true);
					bt_stop->setEnabled(true);
					bt_start->setEnabled(true);
					bt_end->setEnabled(true);
					param_diapo->setEnabled(true);
					bt_img_effects->setEnabled(true);
					bt_fond->setEnabled(true);
					bt_screenshot->setEnabled(true);
					frame_toptimeline->setEnabled(true);
					contain_timeline->setEnabled(true);
					affichage_diapo();
					f_calcul_son();
				}
				else
				{
					lcdlength->display(0);
				}
				if ( zik_number > 0 )
				{
					int duree = table_zik[0][1].toInt();
					total_audio = 0;
					total_audio = total_audio + duree;
					int tmpvar2 = table_zik[0][0].lastIndexOf("/");
					titre_audio->setText(table_zik[0][0].mid(tmpvar2 + 1,table_zik[0][0].length() - (tmpvar2+1)));
					lcddursound->display(duree);
					zik_1->setText(table_zik[0][0]);
					zik_1->show();
					f_calcul_son();
					//
					bt_add_zik->setDisabled(true);
					bt_supp_zik->setEnabled(true);
					bt_sync->setEnabled(true);
				}
				// *** Fin du traitement ***
				myfic.close();
			}
		}
		else
		{
			if ( ispreview == 2 )
			{
				this->setEnabled(true);
				QPixmap wl_pix_1;
				if ( wl_pix_1.load(wpathprojet + "/" + table_photos[current_diapo][0]) == true )
				{
					QLabel *mylabel;
					QIcon myicon = lst_transitions->itemIcon(lst_transitions->currentIndex());
					mylabel = table_pnt_img[current_diapo];
					QPixmap wl_pix_2(wg_diapositive);
					QPixmap wl_pix_3(83,63);
					if ( wl_pix_1.height() > wl_pix_1.width() )
					{
						wl_pix_3 = wl_pix_1.scaledToHeight ( 63, Qt::FastTransformation );
					}
					else
					{
						wl_pix_3 = wl_pix_1.scaledToWidth ( 83, Qt::FastTransformation );
					}
					QPainter p;
					p.begin(&wl_pix_2);
					p.drawPixmap(7 + ((83 - wl_pix_3.width()) / 2), 7, wl_pix_3, 0, 0, 83, 63 );
					if ( table_photos[current_diapo][24] != "" )
					{
						p.drawPixmap(2, 57, wg_comment, 0, 0, -1, -1 );
					}
					myicon.paint ( &p, 56, 45, 32, 24, Qt::AlignCenter, QIcon::Normal, QIcon::On );
					p.end();
					mylabel->setPixmap(wl_pix_2);
					affichage_diapo();
				}
				else
				{
					QMessageBox::information(this, "Manslide", tr("Erreur recuperation image depuis The Gimp."));
				}
			}
			else
			{
				if ( ispreview == 4 )
				{
					this->close();
				}
				else
				{
					if ( ispreview == 5 )
					{
						comboeffets->clear();
						comboeffets->insertItem(0,tr("Aucun"));
						QDir wcurrentDir(wg_library + "/BIB_ManSlide/Effects/");
						QStringList filters;
						filters << "*.*";
						int positem = 1;
						QDir subdir;

						foreach (QString file, wcurrentDir.entryList(QDir::Dirs | QDir::NoDotAndDotDot))
						{
							comboeffets->insertItem(positem, file);
							subdir.setPath(wg_library + "/BIB_ManSlide/Effects/" + file);
							pntmygl->table_effets[positem][0] = file;
							pntmygl->table_effets[positem][1] = QString::number(subdir.count());
							positem = positem + 1;
						}
						comboeffets->setCurrentIndex(0);
						pntmygl->iseffect = 0;
						table_photos[current_diapo][22] = "";
						pntmygl->load_effet(0,"");
					}
				}
			}
		}
	}
}

void mainfrm::f_open_proj()
{
	QString wmyfic = QFileDialog::getOpenFileName(this, tr("Ouvrir un projet"), "~", tr("Projet (*.msz *.MSZ)"));
        if ( wmyfic.isNull() )
        {
        }
        else
        {
        	QFile myfic2(QDir::tempPath() + "/open.sh");

        	if ( !myfic2.open( QIODevice::WriteOnly ))
        	{
			QMessageBox::information(this, "Manslide", tr("Erreur lors de l ouverture du projet"));
			return;
		}
		else
		{
			QTextStream out2(&myfic2);
			//
			ispreview = 0;
			out2 << "#!/bin/bash" << endl;
			out2 << "cd " << QDir::tempPath() << endl;
			out2 << "tar -xf " << wmyfic << endl;
			out2 << "rm -f open.sh" << endl;
			myfic2.close();
			QString program = "bash";
       			QStringList arguments;
       			arguments << QDir::tempPath() + "/open.sh";
       			myprocess_9.start( program, arguments );
		}
	}
}

void mainfrm::f_sync()
{
	this->setDisabled(true);
	int dur_by_slide = total_audio / (nbre_photos + 1);
	int dur_by_trans = 2;
	if ( dur_by_slide < 1 )
	{
		dur_by_slide = 1;
		dur_by_trans = 1;
	}
	int i = 0;
	while ( i <= nbre_photos )
	{
		if ( table_photos[i][20].toInt() > 0 )
		{
			table_photos[i][16] = QString::number(dur_by_slide);
			table_photos[i][21] = QString::number(dur_by_trans);
		}
		else
		{
			table_photos[i][16] = QString::number(dur_by_slide);
		}
		i = i + 1;
	}
	spindurtrans->setValue(table_photos[i][current_diapo].toInt());
	spindurdiapo->setValue(dur_by_slide);
	spindurpausefirst->setValue(0);
	spindurpauselast->setValue(0);
	f_calcul_son();
	this->setEnabled(true);
}

void mainfrm::f_raz()
{
	table_photos[current_diapo][1] = QString::number(0);
	table_photos[current_diapo][2] = QString::number(0);
	table_photos[current_diapo][3] = QString::number(-4);
	table_photos[current_diapo][4] = QString::number(0);
	table_photos[current_diapo][5] = QString::number(0);
	table_photos[current_diapo][6] = QString::number(0);
	//
	table_photos[current_diapo][7] = QString::number(0);
	table_photos[current_diapo][8] = QString::number(0);
	table_photos[current_diapo][9] = QString::number(-4);
	table_photos[current_diapo][10] = QString::number(0);
	table_photos[current_diapo][11] = QString::number(0);
	table_photos[current_diapo][12] = QString::number(0);
	//
	must_redraw = 0;
        affichage_diapo();
}

void mainfrm::f_copy()
{
	tmp_cpast[0] = table_photos[current_diapo][1];
	tmp_cpast[1] = table_photos[current_diapo][2];
	tmp_cpast[2] = table_photos[current_diapo][3];
	tmp_cpast[3] = table_photos[current_diapo][4];
	tmp_cpast[4] = table_photos[current_diapo][5];
	tmp_cpast[5] = table_photos[current_diapo][6];
	//
	tmp_cpast[6] = table_photos[current_diapo][7];
	tmp_cpast[7] = table_photos[current_diapo][8];
	tmp_cpast[8] = table_photos[current_diapo][9];
	tmp_cpast[9] = table_photos[current_diapo][10];
	tmp_cpast[10] = table_photos[current_diapo][11];
	tmp_cpast[11] = table_photos[current_diapo][12];
	//
	bt_paste_all->setEnabled(true);
}

void mainfrm::f_paste()
{
	table_photos[current_diapo][1] = tmp_cpast[0];
	table_photos[current_diapo][2] = tmp_cpast[1];
	table_photos[current_diapo][3] = tmp_cpast[2];
	table_photos[current_diapo][4] = tmp_cpast[3];
	table_photos[current_diapo][5] = tmp_cpast[4];
	table_photos[current_diapo][6] = tmp_cpast[5];
	//
	table_photos[current_diapo][7] = tmp_cpast[6];
	table_photos[current_diapo][8] = tmp_cpast[7];
	table_photos[current_diapo][9] = tmp_cpast[8];
	table_photos[current_diapo][10] = tmp_cpast[9];
	table_photos[current_diapo][11] = tmp_cpast[10];
	table_photos[current_diapo][12] = tmp_cpast[11];
	//
	must_redraw = 0;
        affichage_diapo();
}

void mainfrm::f_pos_leg(int valeur)
{
	table_photos[current_diapo][23] = QString::number(valeur);
	pntmygl->effet_titre = valeur;
	pntmygl->x_titre = -1.8;
	pntmygl->updateGL();
}

void mainfrm::f_couleur()
{
        pntmygl->mycolor = QColorDialog::getColor(pntmygl->mycolor, this);
        if (pntmygl->mycolor.isValid())
	{
		pntmygl->updateGL();
        }
}

void mainfrm::f_police()
{
	bool ok;
	pntmygl->myfont = QFontDialog::getFont(&ok, pntmygl->myfont, this);
    	if (ok) 
	{
		pntmygl->updateGL();
	}
}

void mainfrm::f_chg_leg(QString saitxt)
{
	table_photos[current_diapo][17] = saitxt;
	pntmygl->txt_sur_image = saitxt;
	pntmygl->updateGL();
}

void mainfrm::f_chg_tool_a()
{
	pntmygl->tool = 1;
}

void mainfrm::f_chg_tool_b()
{
	pntmygl->tool = 2;
}

void mainfrm::f_chg_tool_c()
{
	pntmygl->tool = 3;
}

void mainfrm::f_chg_tool_d()
{
	pntmygl->tool = 4;
}

void mainfrm::f_chg_tool_e()
{
	pntmygl->tool = 5;
}

void mainfrm::f_chg_tool_f()
{
	pntmygl->tool = 6;
}

void mainfrm::f_durp_deb(int valeur)
{
	table_photos[current_diapo][19] = QString::number(valeur);
	pntmygl->pause_debut = valeur;
	f_calcul_son();
}

void mainfrm::f_durp_end(int valeur)
{
	table_photos[current_diapo][18] = QString::number(valeur);
	pntmygl->pause_fin = valeur;
	f_calcul_son();
}

void mainfrm::f_opacity(int valeur)
{
	table_photos[current_diapo][15] = QString::number(dial_opacity->value());
	pntmygl->sl_opacity(valeur);
}

void mainfrm::f_percent_blending(int valeur)
{
	table_photos[current_diapo][25] = QString::number(dial_percent_blending->value());
	pntmygl->wg_percent = table_photos[current_diapo][25].toFloat() / 100;
	label_percent_1->setText( table_photos[current_diapo][25] + " %");
	if ( position_flux == 0 )
	{
		pntmygl->updateGL();
	}
}

void mainfrm::f_percent_blending_2(int valeur)
{
	table_photos[current_diapo][26] = QString::number(dial_percent_blending_2->value());
	pntmygl->wg_percent = table_photos[current_diapo][26].toFloat() / 100;
	label_percent_2->setText( table_photos[current_diapo][26] + " %");
	if ( position_flux == 1 )
	{
		pntmygl->updateGL();
	}
}

void mainfrm::f_brouillard(int valeur)
{
	if ( valeur == 0)
	{
		table_photos[current_diapo][14] = "0";
	}
	else
	{
		table_photos[current_diapo][14] = "1";
		pntmygl->change_fog_color();
		table_photos[current_diapo][15] = QString::number(dial_opacity->value());
	}
	pntmygl->sl_brouillard(valeur);
}

void mainfrm::f_change_fond()
{
        QString myfic = QFileDialog::getOpenFileName(
                this,
                "Ouvrir un fichier",
                "~",
                "Images (*.jpg *.JPG *.jpeg *.JPEG *.png *.PNG)");
        if ( myfic.isNull() )
        {
        }
        else
        {
		QPixmap wl_pix_1(myfic);
		QPixmap wl_pix_2(720,576);
		QPixmap wl_pix_3;
		wl_pix_2.fill(Qt::black);

		if ( wl_pix_1.width() > wl_pix_1.height() )
		{
			wl_pix_3 = wl_pix_1.scaledToWidth ( 720, Qt::FastTransformation );
		}
		else
		{
			wl_pix_3 = wl_pix_1.scaledToHeight ( 576, Qt::FastTransformation );
		}
		QPainter p;
        	p.begin(&wl_pix_2);
		p.drawPixmap(((720 - wl_pix_3.width()) / 2), ((576 - wl_pix_3.height()) / 2), wl_pix_3, 0, 0, -1, -1 );
		p.end();
            	int i = myfic.lastIndexOf( '/' );
            	if ( i != -1 )
            	{
                	outfilename = myfic.mid(i, myfic.length() - i);
			wl_pix_2.save(wpathprojet + "/" + outfilename + ".jpg","JPEG",75);
			//
			table_photos[current_diapo][13] = outfilename + ".jpg";
			pntmygl->sl_change_fond(wpathprojet + "/" + outfilename + ".jpg");
			pntmygl->updateGL();
		}
	}
}

void mainfrm::f_sup_zik()
{
	zik_number = zik_number - 1;
	total_audio = 0;
	titre_audio->setText("");
	lcddursound->display(0);
	bt_supp_zik->setDisabled(true);
	frame_fade->setDisabled(true);
	bt_sync->setDisabled(true);
	bt_add_zik->setEnabled(true);
	zik_1->hide();
}

void mainfrm::f_add_zik()
{
	if ( zik_number < 1 )
	{
        	QString myfic = QFileDialog::getOpenFileName(
                	this,
                	tr("Ouvrir un fichier"),
                	path_photos_import,
                	"Musiques (*.OGG *.ogg)");
        	if ( myfic.isNull() )
        	{
        	}
        	else
        	{
			int tmpvar2 = myfic.lastIndexOf("/");
			QFile::copy ( myfic, wpathprojet + "/" + myfic.mid(tmpvar2 + 1,myfic.length() - (tmpvar2+1)) );
			table_zik[0][0] = myfic.mid(tmpvar2 + 1,myfic.length() - (tmpvar2+1));
			wglob_str_1 = "";
			QString program = "ogginfo";
       			QStringList arguments;
       			arguments << myfic;
       			myprocess_5.start( program, arguments );
		}
	}
	else
	{
		QMessageBox::information(this, "Manslide", tr("le nombre maximum de bandes son est de 1 pour l'instant. Desole ..."));
	}
}

void mainfrm::lecture_console_import_zik()
{
	QByteArray newData = myprocess_5.readAllStandardOutput();
	QString wl_var_1 = QString::fromLocal8Bit(newData);
	wglob_str_1 = wglob_str_1 + wl_var_1;
}

void mainfrm::end_zik_import(int, QProcess::ExitStatus)
{
	myprocess_5.terminate();
        int i = wglob_str_1.indexOf("Playback length:", 0);
        if ( i != -1 )
        {
		QString wl_str_1 = "0";
		QString wl_str_2 = "0";
		int bascule = 0;

		while ( wglob_str_1.mid(i + 17, 1) != "." )
		{
			if ( wglob_str_1.mid(i + 17, 1) != "m" )
			{
				if ( bascule == 0 )
				{
					wl_str_1 = wl_str_1 + wglob_str_1.mid(i + 17,1);
				}
				else
				{
					wl_str_2 = wl_str_2 + wglob_str_1.mid(i + 17,1);
				}
			}
			else
			{
				bascule = 1;
				i = i + 1;
			}
			i = i + 1;
		}
		int wz1 = wl_str_1.toInt() * 60;
		int wz2 = wl_str_2.toInt();
		int duree = wz1 + wz2;

		total_audio = 0;
		total_audio = total_audio + duree;

		titre_audio->setText(table_zik[zik_number][0]);
		lcddursound->display(duree);
		zik_1->setText(table_zik[0][0]);
		zik_1->show();
		table_zik[0][1] = QString::number(duree);
		frame_fade->setEnabled(true);
		bt_sync->setEnabled(true);
		bt_supp_zik->setEnabled(true);
		zik_number = zik_number + 1;
		bt_add_zik->setDisabled(true);
		f_calcul_son();
        }
}

void mainfrm::f_calcul_son()
{
	int j=0;
	int cumul_diapo = 0;
	int total_diapo = 0;
	int duree = table_zik[0][1].toInt();
	while ( j <= nbre_photos )
	{
		total_diapo = total_diapo + ( table_photos[j][16].toInt() + table_photos[j][18].toInt() + table_photos[j][19].toInt() );
		j = j + 1;
	}
	lcdlength->display(total_diapo);
	if ( zik_number > 0 )
	{
		j = 0;
		while ( cumul_diapo < duree && j <= nbre_photos )
		{
			cumul_diapo = cumul_diapo + ( table_photos[j][16].toInt() + table_photos[j][18].toInt() + table_photos[j][19].toInt() );
			j = j + 1;
		}
		if ( duree > cumul_diapo )
		{
			zik_1->setGeometry(0,87,((j + 1) * 110),21);
		}
		else
		{
			if ( duree < cumul_diapo )
			{
				zik_1->setGeometry(0,87,(j * 110) - 50,21);
			}
			else
			{
				zik_1->setGeometry(0,87,(j * 110) - 10 ,21);
			}
		}
	}
}

void mainfrm::f_apply_effets(int state)
{
	if ( comboeffets->count() > 0 )
	{
		if (state == 0)
		{
			pntmygl->iseffect = 0;
			pntmygl->nameanim = "";
			table_photos[current_diapo][22] = "0";
			pntmygl->updateGL();
		}
		else
		{
			pntmygl->iseffect = state;
			//pntmygl->nameanim = comboeffets->currentText();
			pntmygl->maxanim = pntmygl->table_effets[state][1].toInt();
			table_photos[current_diapo][22] = comboeffets->currentText();
			pntmygl->load_effet(state,comboeffets->currentText());
			pntmygl->updateGL();
		}
	}
}

void mainfrm::f_dep_droite()
{
	must_redraw = 0;
// *** Deplacement images vers droite ***
    	if ( nbre_photos > 0 )
    	{
        	int cpt1;
        	QLabel *mylabel;
        	QString tmp_tab[1][28];
		QLabel *tmppnt;
        	cpt1 = current_diapo;
        	QColor tmpcolor(0,0,0);

        	if ( nbre_photos > 0 && current_diapo < nbre_photos )
        	{
            		mylabel = table_pnt_img[cpt1];
		        //
        		mylabel->setGeometry( (((cpt1 + 1) * 97) + ((cpt1 + 1) * 10)) , 0 , 97, 77);
			img_selection->setGeometry( (((cpt1 + 1) * 97) + ((cpt1 + 1) * 10)), 0, 97, 77);
            		// *** Decalage des pointeurs et autres ***
            		tmppnt = table_pnt_img[cpt1];
            		tmp_tab[0][0] = table_photos[cpt1][0];
            		tmp_tab[0][1] = table_photos[cpt1][1];
            		tmp_tab[0][2] = table_photos[cpt1][2];
            		tmp_tab[0][3] = table_photos[cpt1][3];
            		tmp_tab[0][4] = table_photos[cpt1][4];
            		tmp_tab[0][5] = table_photos[cpt1][5];
            		tmp_tab[0][6] = table_photos[cpt1][6];
            		tmp_tab[0][7] = table_photos[cpt1][7];
            		tmp_tab[0][8] = table_photos[cpt1][8];
            		tmp_tab[0][9] = table_photos[cpt1][9];
            		tmp_tab[0][10] = table_photos[cpt1][10];
            		tmp_tab[0][11] = table_photos[cpt1][11];
            		tmp_tab[0][12] = table_photos[cpt1][12];
            		tmp_tab[0][13] = table_photos[cpt1][13];
            		tmp_tab[0][14] = table_photos[cpt1][14];
            		tmp_tab[0][15] = table_photos[cpt1][15];
            		tmp_tab[0][16] = table_photos[cpt1][16];
            		tmp_tab[0][17] = table_photos[cpt1][17];
            		tmp_tab[0][18] = table_photos[cpt1][18];
            		tmp_tab[0][19] = table_photos[cpt1][19];
            		tmp_tab[0][20] = table_photos[cpt1][20];
            		tmp_tab[0][21] = table_photos[cpt1][21];
            		tmp_tab[0][22] = table_photos[cpt1][22];
            		tmp_tab[0][23] = table_photos[cpt1][23];
            		tmp_tab[0][24] = table_photos[cpt1][24];
            		tmp_tab[0][25] = table_photos[cpt1][25];
            		tmp_tab[0][26] = table_photos[cpt1][26];
            		tmp_tab[0][27] = table_photos[cpt1][27];
			tmpcolor = table_color_fog[cpt1];
			//
            		mylabel = table_pnt_img[cpt1 + 1];
		        //
        		mylabel->setGeometry( ((((cpt1) * 97)) + ((cpt1) * 10)), 0 , 97, 77);
            		// *** Decalage des pointeurs et autres ***
            		table_pnt_img[cpt1] = table_pnt_img[cpt1 + 1];
            		table_photos[cpt1][0] = table_photos[cpt1 + 1][0];
            		table_photos[cpt1][1] = table_photos[cpt1 + 1][1];
            		table_photos[cpt1][2] = table_photos[cpt1 + 1][2];
            		table_photos[cpt1][3] = table_photos[cpt1 + 1][3];
            		table_photos[cpt1][4] = table_photos[cpt1 + 1][4];
            		table_photos[cpt1][5] = table_photos[cpt1 + 1][5];
            		table_photos[cpt1][6] = table_photos[cpt1 + 1][6];
            		table_photos[cpt1][7] = table_photos[cpt1 + 1][7];
            		table_photos[cpt1][8] = table_photos[cpt1 + 1][8];
            		table_photos[cpt1][9] = table_photos[cpt1 + 1][9];
            		table_photos[cpt1][10] = table_photos[cpt1 + 1][10];
            		table_photos[cpt1][11] = table_photos[cpt1 + 1][11];
            		table_photos[cpt1][12] = table_photos[cpt1 + 1][12];
            		table_photos[cpt1][13] = table_photos[cpt1 + 1][13];
            		table_photos[cpt1][14] = table_photos[cpt1 + 1][14];
            		table_photos[cpt1][15] = table_photos[cpt1 + 1][15];
            		table_photos[cpt1][16] = table_photos[cpt1 + 1][16];
            		table_photos[cpt1][17] = table_photos[cpt1 + 1][17];
            		table_photos[cpt1][18] = table_photos[cpt1 + 1][18];
            		table_photos[cpt1][19] = table_photos[cpt1 + 1][19];
            		table_photos[cpt1][20] = table_photos[cpt1 + 1][20];
            		table_photos[cpt1][21] = table_photos[cpt1 + 1][21];
            		table_photos[cpt1][22] = table_photos[cpt1 + 1][22];
            		table_photos[cpt1][23] = table_photos[cpt1 + 1][23];
            		table_photos[cpt1][24] = table_photos[cpt1 + 1][24];
            		table_photos[cpt1][25] = table_photos[cpt1 + 1][25];
            		table_photos[cpt1][26] = table_photos[cpt1 + 1][26];
            		table_photos[cpt1][27] = table_photos[cpt1 + 1][27];
			table_color_fog[cpt1] = table_color_fog[cpt1 + 1];
			//
            		table_pnt_img[cpt1 + 1] = tmppnt;
            		table_photos[cpt1 + 1][0] = tmp_tab[0][0];
            		table_photos[cpt1 + 1][1] = tmp_tab[0][1];
            		table_photos[cpt1 + 1][2] = tmp_tab[0][2];
            		table_photos[cpt1 + 1][3] = tmp_tab[0][3];
            		table_photos[cpt1 + 1][4] = tmp_tab[0][4];
            		table_photos[cpt1 + 1][5] = tmp_tab[0][5];
            		table_photos[cpt1 + 1][6] = tmp_tab[0][6];
            		table_photos[cpt1 + 1][7] = tmp_tab[0][7];
            		table_photos[cpt1 + 1][8] = tmp_tab[0][8];
            		table_photos[cpt1 + 1][9] = tmp_tab[0][9];
            		table_photos[cpt1 + 1][10] = tmp_tab[0][10];
            		table_photos[cpt1 + 1][11] = tmp_tab[0][11];
            		table_photos[cpt1 + 1][12] = tmp_tab[0][12];
            		table_photos[cpt1 + 1][13] = tmp_tab[0][13];
            		table_photos[cpt1 + 1][14] = tmp_tab[0][14];
            		table_photos[cpt1 + 1][15] = tmp_tab[0][15];
            		table_photos[cpt1 + 1][16] = tmp_tab[0][16];
            		table_photos[cpt1 + 1][17] = tmp_tab[0][17];
            		table_photos[cpt1 + 1][18] = tmp_tab[0][18];
            		table_photos[cpt1 + 1][19] = tmp_tab[0][19];
            		table_photos[cpt1 + 1][20] = tmp_tab[0][20];
            		table_photos[cpt1 + 1][21] = tmp_tab[0][21];
            		table_photos[cpt1 + 1][22] = tmp_tab[0][22];
            		table_photos[cpt1 + 1][23] = tmp_tab[0][23];
            		table_photos[cpt1 + 1][24] = tmp_tab[0][24];
            		table_photos[cpt1 + 1][25] = tmp_tab[0][25];
            		table_photos[cpt1 + 1][26] = tmp_tab[0][26];
            		table_photos[cpt1 + 1][27] = tmp_tab[0][27];
			table_color_fog[cpt1 + 1] = tmpcolor;
			//
            		current_diapo = cpt1 + 1;
		}
        }
}

void mainfrm::f_dep_gauche()
{
	must_redraw = 0;
// *** Deplacement images vers gauche ***
    	if ( nbre_photos > 0 )
    	{
        	int cpt1;
        	QLabel *mylabel;
        	QString tmp_tab[1][28];
		QLabel *tmppnt;
        	cpt1 = current_diapo;
		QColor tmpcolor(0,0,0);
        
        	if ( nbre_photos > 0 && current_diapo > 0 )
        	{
            		mylabel = table_pnt_img[cpt1];
		        //
        		mylabel->setGeometry( (((cpt1 - 1) * 97) + ((cpt1 - 1) * 10)) , 0 , 97, 77);
			img_selection->setGeometry( (((cpt1 - 1) * 97) + ((cpt1 - 1) * 10)), 0, 97, 77);
            		// *** Decalage des pointeurs et autres ***
            		tmppnt = table_pnt_img[cpt1];
            		tmp_tab[0][0] = table_photos[cpt1][0];
            		tmp_tab[0][1] = table_photos[cpt1][1];
            		tmp_tab[0][2] = table_photos[cpt1][2];
            		tmp_tab[0][3] = table_photos[cpt1][3];
            		tmp_tab[0][4] = table_photos[cpt1][4];
            		tmp_tab[0][5] = table_photos[cpt1][5];
            		tmp_tab[0][6] = table_photos[cpt1][6];
            		tmp_tab[0][7] = table_photos[cpt1][7];
            		tmp_tab[0][8] = table_photos[cpt1][8];
            		tmp_tab[0][9] = table_photos[cpt1][9];
            		tmp_tab[0][10] = table_photos[cpt1][10];
            		tmp_tab[0][11] = table_photos[cpt1][11];
            		tmp_tab[0][12] = table_photos[cpt1][12];
            		tmp_tab[0][13] = table_photos[cpt1][13];
            		tmp_tab[0][14] = table_photos[cpt1][14];
            		tmp_tab[0][15] = table_photos[cpt1][15];
            		tmp_tab[0][16] = table_photos[cpt1][16];
            		tmp_tab[0][17] = table_photos[cpt1][17];
            		tmp_tab[0][18] = table_photos[cpt1][18];
            		tmp_tab[0][19] = table_photos[cpt1][19];
            		tmp_tab[0][20] = table_photos[cpt1][20];
            		tmp_tab[0][21] = table_photos[cpt1][21];
            		tmp_tab[0][22] = table_photos[cpt1][22];
            		tmp_tab[0][23] = table_photos[cpt1][23];
            		tmp_tab[0][24] = table_photos[cpt1][24];
            		tmp_tab[0][25] = table_photos[cpt1][25];
            		tmp_tab[0][26] = table_photos[cpt1][26];
            		tmp_tab[0][27] = table_photos[cpt1][27];
			tmpcolor = table_color_fog[cpt1];
			//
            		mylabel = table_pnt_img[cpt1 - 1];
		        //
        		mylabel->setGeometry( ((((cpt1) * 97)) + ((cpt1) * 10)), 0 , 97, 77);
            		// *** Decalage des pointeurs et autres ***
            		table_pnt_img[cpt1] = table_pnt_img[cpt1 - 1];
            		table_photos[cpt1][0] = table_photos[cpt1 - 1][0];
            		table_photos[cpt1][1] = table_photos[cpt1 - 1][1];
            		table_photos[cpt1][2] = table_photos[cpt1 - 1][2];
            		table_photos[cpt1][3] = table_photos[cpt1 - 1][3];
            		table_photos[cpt1][4] = table_photos[cpt1 - 1][4];
            		table_photos[cpt1][5] = table_photos[cpt1 - 1][5];
            		table_photos[cpt1][6] = table_photos[cpt1 - 1][6];
            		table_photos[cpt1][7] = table_photos[cpt1 - 1][7];
            		table_photos[cpt1][8] = table_photos[cpt1 - 1][8];
            		table_photos[cpt1][9] = table_photos[cpt1 - 1][9];
            		table_photos[cpt1][10] = table_photos[cpt1 - 1][10];
            		table_photos[cpt1][11] = table_photos[cpt1 - 1][11];
            		table_photos[cpt1][12] = table_photos[cpt1 - 1][12];
            		table_photos[cpt1][13] = table_photos[cpt1 - 1][13];
            		table_photos[cpt1][14] = table_photos[cpt1 - 1][14];
            		table_photos[cpt1][15] = table_photos[cpt1 - 1][15];
            		table_photos[cpt1][16] = table_photos[cpt1 - 1][16];
            		table_photos[cpt1][17] = table_photos[cpt1 - 1][17];
            		table_photos[cpt1][18] = table_photos[cpt1 - 1][18];
            		table_photos[cpt1][19] = table_photos[cpt1 - 1][19];
            		table_photos[cpt1][20] = table_photos[cpt1 - 1][20];
            		table_photos[cpt1][21] = table_photos[cpt1 - 1][21];
            		table_photos[cpt1][22] = table_photos[cpt1 - 1][22];
            		table_photos[cpt1][23] = table_photos[cpt1 - 1][23];
            		table_photos[cpt1][24] = table_photos[cpt1 - 1][24];
            		table_photos[cpt1][25] = table_photos[cpt1 - 1][25];
            		table_photos[cpt1][26] = table_photos[cpt1 - 1][26];
            		table_photos[cpt1][27] = table_photos[cpt1 - 1][27];
			table_color_fog[cpt1] = table_color_fog[cpt1 - 1];
			//
            		table_pnt_img[cpt1 - 1] = tmppnt;
            		table_photos[cpt1 - 1][0] = tmp_tab[0][0];
            		table_photos[cpt1 - 1][1] = tmp_tab[0][1];
            		table_photos[cpt1 - 1][2] = tmp_tab[0][2];
            		table_photos[cpt1 - 1][3] = tmp_tab[0][3];
            		table_photos[cpt1 - 1][4] = tmp_tab[0][4];
            		table_photos[cpt1 - 1][5] = tmp_tab[0][5];
            		table_photos[cpt1 - 1][6] = tmp_tab[0][6];
            		table_photos[cpt1 - 1][7] = tmp_tab[0][7];
            		table_photos[cpt1 - 1][8] = tmp_tab[0][8];
            		table_photos[cpt1 - 1][9] = tmp_tab[0][9];
            		table_photos[cpt1 - 1][10] = tmp_tab[0][10];
            		table_photos[cpt1 - 1][11] = tmp_tab[0][11];
            		table_photos[cpt1 - 1][12] = tmp_tab[0][12];
            		table_photos[cpt1 - 1][13] = tmp_tab[0][13];
            		table_photos[cpt1 - 1][14] = tmp_tab[0][14];
            		table_photos[cpt1 - 1][15] = tmp_tab[0][15];
            		table_photos[cpt1 - 1][16] = tmp_tab[0][16];
            		table_photos[cpt1 - 1][17] = tmp_tab[0][17];
            		table_photos[cpt1 - 1][18] = tmp_tab[0][18];
            		table_photos[cpt1 - 1][19] = tmp_tab[0][19];
            		table_photos[cpt1 - 1][20] = tmp_tab[0][20];
            		table_photos[cpt1 - 1][21] = tmp_tab[0][21];
            		table_photos[cpt1 - 1][22] = tmp_tab[0][22];
            		table_photos[cpt1 - 1][23] = tmp_tab[0][23];
            		table_photos[cpt1 - 1][24] = tmp_tab[0][24];
            		table_photos[cpt1 - 1][25] = tmp_tab[0][25];
            		table_photos[cpt1 - 1][26] = tmp_tab[0][26];
            		table_photos[cpt1 - 1][27] = tmp_tab[0][27];
			table_color_fog[cpt1 - 1] = tmpcolor;
			//
            		current_diapo = cpt1 - 1;
		}
        }
}

void mainfrm::f_screenshot()
{
	QString s = QFileDialog::getSaveFileName(
        	this,
                tr("Nom de l'image enregistree"),
                path_photos_import,
                "Images (*.jpg)");
        if ( s.isNull() )
        {
        }
        else
	{
		if ( s.mid(s.length() - 4,4) != ".jpg" )
		{
			s = s + ".jpg";
		}
		pntmygl->grabframe(s);
	}
}

void mainfrm::f_close_param_import()
{
	frame_topmenu->setEnabled(true);
	contain_timeline->setEnabled(true);
	menu_projet->setEnabled(true);
	frame_zik->setEnabled(true);
	frame_telecomm->setEnabled(true);
	menu_images->setEnabled(true);
	frame_parameters->setEnabled(true);
	param_encoding->setEnabled(true);
	bt_start->setEnabled(true);
	bt_stop->setEnabled(true);
	bt_play->setEnabled(true);
	bt_end->setEnabled(true);
	frame_parametres->hide();
}

void mainfrm::f_affiche_parametres()
{
	frame_topmenu->setDisabled(true);
	contain_timeline->setDisabled(true);
	menu_projet->setDisabled(true);
	frame_zik->setDisabled(true);
	frame_telecomm->setDisabled(true);
	menu_images->setDisabled(true);
	frame_parameters->setDisabled(true);
	param_encoding->setDisabled(true);
	bt_start->setDisabled(true);
	bt_stop->setDisabled(true);
	bt_play->setDisabled(true);
	bt_end->setDisabled(true);
	frame_parametres->setGeometry(399,206,201,211);
	frame_parametres->show();
	frame_parametres->raise();
}

void mainfrm::f_changedur(int valeur)
{
	if ( nbre_photos >= 0 )
	{
		table_photos[current_diapo][16] = QString::number(valeur);
		pntmygl->wg_duree = valeur;
		spindurtrans->setMaximum(valeur);
		f_calcul_son();
	}
	else
	{
		pntmygl->wg_duree = 1;
		spindurdiapo->setValue(1);
	}
}

void mainfrm::f_render()
{
	int i;
	int k;
	int l;
	int m;
	int n;
	int o;
	int wl_width;
	int wl_height;
	int isfirst;
	int wfrom = from_encoding->value();
	int wto = to_encoding->value();
	int wl_qualite;
	if ( comboqualite->currentIndex() == 0 )
	{
		pntmygl->wg_qualite = 100;
		wl_qualite = 100;
	}
	else
	{
		if ( comboqualite->currentIndex() == 1 )
		{
			pntmygl->wg_qualite = 75;
			wl_qualite = 75;
		}
		else
		{
			if ( comboqualite->currentIndex() == 2 )
			{
				pntmygl->wg_qualite = 40;
				wl_qualite = 40;
			}
			else
			{
				pntmygl->wg_qualite = 10;
				wl_qualite = 10;
			}
		}
	}
	if ( ispreview == 1 )
	{
		pntmygl->wg_qualite = 30;
		wl_qualite = 30;
	}
	QString tmp_tab[1][25];
	i = wfrom - 1;
	if ( ispreview == 1 )
	{
		if (current_diapo > 0)
		{
			wfrom = current_diapo - 1;
			//
        		tmp_tab[0][1] = table_photos[wfrom][1];
        		tmp_tab[0][2] = table_photos[wfrom][2];
        		tmp_tab[0][3] = table_photos[wfrom][3];
        		tmp_tab[0][4] = table_photos[wfrom][4];
        		tmp_tab[0][5] = table_photos[wfrom][5];
        		tmp_tab[0][6] = table_photos[wfrom][6];
        		tmp_tab[0][18] = table_photos[wfrom][18];
        		tmp_tab[0][19] = table_photos[wfrom][19];
        		tmp_tab[0][16] = table_photos[wfrom][16];
        		tmp_tab[0][20] = table_photos[wfrom][20];
			//
			table_photos[wfrom][1] = table_photos[wfrom][7];
			table_photos[wfrom][2] = table_photos[wfrom][8];
			table_photos[wfrom][3] = table_photos[wfrom][9];
			table_photos[wfrom][4] = table_photos[wfrom][10];
			table_photos[wfrom][5] = table_photos[wfrom][11];
			table_photos[wfrom][6] = table_photos[wfrom][12];
			table_photos[wfrom][16] = QString::number(1);
			table_photos[wfrom][18] = QString::number(0);
			table_photos[wfrom][19] = QString::number(0);
			table_photos[wfrom][20] = QString::number(0);
			//
			isfirst = 0;
		}
		else
		{
			isfirst = 1;
			wfrom = current_diapo;
		}
		wto = current_diapo + 1;
		i = wfrom;
	}
	else
	{
		M_BT_EXPORT->setDisabled(true);
	}
	wl_width = 720;
	wl_height = 576;
	int wstart = 0;
	int wstart_2 = 0;
	int wend = 0;
	int wprogress = 0;
	int wprogress_2 = 0;
	int wl_total_frame = 0;
	int idxsearch = 1;
	QString nomeffet;
	pntmygl->frame_encoding = 0;
	QString wstartfile;
	QString wendfile;
	QString woutfile;
	QString tmp_001;
	QImage wl_img_1;
	QImage wl_img_2(wl_width,wl_height,QImage::Format_ARGB32);
	QImage wl_img_3;
	QImage wl_img_4(wl_width,wl_height,QImage::Format_ARGB32);
        QPainter p;
	QString wl_tmp_1;
	QString wl_var_1 = "000000";
	QString wl_var_2 = "000000";
	QString wl_var_3 = "0";
	QString wl_var_4 = "0";
	QString	wl_var_5 = "0";
	QString	wl_var_6 = "0";
        QFile myfic(wpathprojet + "/encode.sh");

        if ( !myfic.open( QIODevice::WriteOnly ))
        {
		return;
	}
	QTextStream out(&myfic);
	out << "#!/bin/bash" << endl;
        out << "cd " << wpathprojet << endl;

	while ( i <= wto - 1 )
	{
		pb_img_magick->setValue(0);
		pb_img_magick->setMaximum((table_photos[i][16].toInt() * 25) + (table_photos[i][18].toInt() * 25) + (table_photos[i][19].toInt() * 25));
		pntmygl->numdiapo = i;
       		pntmygl->debut_px = table_photos[i][1].toFloat();
       		pntmygl->debut_py = table_photos[i][2].toFloat();
       		pntmygl->debut_pz = table_photos[i][3].toFloat();
       		pntmygl->debut_rx = table_photos[i][4].toFloat();
       		pntmygl->debut_ry = table_photos[i][5].toFloat();
       		pntmygl->debut_rz = table_photos[i][6].toFloat();
		//
       		pntmygl->fin_px = table_photos[i][7].toFloat();
       		pntmygl->fin_py = table_photos[i][8].toFloat();
       		pntmygl->fin_pz = table_photos[i][9].toFloat();
       		pntmygl->fin_rx = table_photos[i][10].toFloat();
       		pntmygl->fin_ry = table_photos[i][11].toFloat();
       		pntmygl->fin_rz = table_photos[i][12].toFloat();
		//
		pntmygl->rotationX = table_photos[i][4].toFloat();
		pntmygl->rotationY = table_photos[i][5].toFloat();
		pntmygl->rotationZ = table_photos[i][6].toFloat();
		pntmygl->zoom = table_photos[i][3].toFloat();
		pntmygl->deplacementX = table_photos[i][1].toFloat();
		pntmygl->deplacementY = table_photos[i][2].toFloat();
		pntmygl->path_fond = wpathprojet + "/" + table_photos[i][13];
		pntmygl->fogcolor[0] = (float)table_color_fog[i].red() / (float)255;
		pntmygl->fogcolor[1] = (float)table_color_fog[i].green() / (float)255;
		pntmygl->fogcolor[2] = (float)table_color_fog[i].blue() / (float)255;
		pntmygl->fogcolor[3] = 0.5;
		pntmygl->wg_percent = table_photos[i][25].toFloat() / 100;
		//
		if ( table_photos[i][14] == "1" )
		{
			pntmygl->change_fog_color();
			pntmygl->sl_brouillard(1);
			pntmygl->sl_opacity(table_photos[i][15].toInt());
		}
		else
		{
			pntmygl->sl_brouillard(0);
		}
		//
		pntmygl->txt_sur_image = table_photos[i][17];
		pntmygl->wg_duree = table_photos[i][16].toInt();
		pntmygl->type3D = table_photos[i][27].toInt();
		//
		pntmygl->sl_charge_image(wpathprojet + "/" + table_photos[i][0], wpathprojet + "/" + table_photos[i][13]);
		pntmygl->duree = pntmygl->wg_duree * 25;
		pntmygl->progress = 0;
		pntmygl->delta_px = (pntmygl->fin_px - pntmygl->debut_px) / pntmygl->duree;
		pntmygl->delta_py = (pntmygl->fin_py - pntmygl->debut_py) / pntmygl->duree;
		pntmygl->delta_pz = (pntmygl->fin_pz - pntmygl->debut_pz) / pntmygl->duree;
		pntmygl->delta_rx = (pntmygl->fin_rx - pntmygl->debut_rx) / pntmygl->duree;
		pntmygl->delta_ry = (pntmygl->fin_ry - pntmygl->debut_ry) / pntmygl->duree;
		pntmygl->delta_rz = (pntmygl->fin_rz - pntmygl->debut_rz) / pntmygl->duree;
		pntmygl->delta_opacity = ((table_photos[i][26].toFloat() - table_photos[i][25].toFloat()) / pntmygl->duree) / 100;
		pntmygl->wg_percent = table_photos[i][25].toFloat() / 100;
		pntmygl->poursuite = 0;
		pntmygl->effet_titre = table_photos[i][23].toInt();
		pntmygl->duree = pntmygl->wg_duree * 25;
		pntmygl->progress_anim = 1;
		pntmygl->x_titre = 0;
		//
		if ( table_photos[i][22] != "0" )
		{
			wl_var_5 = "000000";
			wl_var_6 = QString::number(pntmygl->progress_anim);
			wl_var_5.replace( 6 - wl_var_6.length(), wl_var_6.length(), wl_var_6);
			//
			idxsearch = 1;
			nomeffet = table_photos[i][22];
			while ( nomeffet != pntmygl->table_effets[idxsearch][0] && idxsearch < 39 )
			{
				idxsearch = idxsearch + 1;
			}
			if ( idxsearch < 39 )
			{
				pntmygl->maxanim = pntmygl->table_effets[idxsearch][1].toInt() - 1;
				pntmygl->iseffect = 1;
			}
			else
			{
				pntmygl->iseffect = 0;
			}
		}
		else
		{
			pntmygl->iseffect = 0;
		}
		while ( pntmygl->progress < pntmygl->duree + (table_photos[i][18].toInt() * 25) + (table_photos[i][19].toInt() * 25))
		{
			if ( pntmygl->iseffect == 1 )
			{
				wl_var_5 = "000000";
				wl_var_6 = QString::number(pntmygl->progress_anim);
				wl_var_5.replace( 6 - wl_var_6.length(), wl_var_6.length(), wl_var_6);
				glDeleteTextures(1, &pntmygl->texture3 );
				pntmygl->a.load(wg_library + "/BIB_ManSlide/Effects/" + nomeffet + "/" + nomeffet + wl_var_5 + ".jpg");
				//
				pntmygl->d = QGLWidget::convertToGLFormat( pntmygl->a );
				glGenTextures( 1, &pntmygl->texture3 );
				glBindTexture( GL_TEXTURE_2D, pntmygl->texture3 );
				glTexImage2D( GL_TEXTURE_2D, 0, 4, pntmygl->d.width(), pntmygl->d.height(), 0, GL_RGBA, GL_UNSIGNED_BYTE, pntmygl->d.bits() );
				glTexParameteri( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST );
				pntmygl->progress_anim = pntmygl->progress_anim + 1;
				if ( pntmygl->progress_anim >= pntmygl->maxanim )
				{
					pntmygl->progress_anim = 1;
				}
			}
			if ( pntmygl->progress > table_photos[i][19].toInt() * 25 && pntmygl->progress <= (table_photos[i][19].toInt() * 25) + pntmygl->duree )
			{
				pntmygl->updateGL();
				pntmygl->grabgl();
				pntmygl->rotationX = pntmygl->rotationX + pntmygl->delta_rx;
				pntmygl->rotationY = pntmygl->rotationY + pntmygl->delta_ry;
				pntmygl->rotationZ = pntmygl->rotationZ + pntmygl->delta_rz;
				pntmygl->deplacementX = pntmygl->deplacementX + pntmygl->delta_px;
				pntmygl->deplacementY = pntmygl->deplacementY + pntmygl->delta_py;
				pntmygl->wg_percent = pntmygl->wg_percent + pntmygl->delta_opacity;
				pntmygl->zoom = pntmygl->zoom + pntmygl->delta_pz;
				pntmygl->progress = pntmygl->progress + 1;
				wl_total_frame = wl_total_frame + 1;
			}
			else
			{
				pntmygl->updateGL();
				pntmygl->grabgl();
				pntmygl->progress = pntmygl->progress + 1;
				wl_total_frame = wl_total_frame + 1;
			}
			pb_img_magick->setValue(pntmygl->progress);
			pntmygl->x_titre = pntmygl->x_titre + pntmygl->v_titre;
		}
		i = i + 1;
	}
	//
	if ( ispreview == 0 )
	{
		param_encoding->show();
	}
	// *** Calcul des transitions ***
	pb_img_magick->setMaximum(100);
	pb_img_magick->setValue(100);
	o = 0;
	i = wfrom - 1;
	if ( ispreview == 1 )
	{
		if (current_diapo > 0)
		{
			wfrom = current_diapo - 1;
		}
		else
		{
			wfrom = current_diapo;
		}
		wto = current_diapo + 1;
		i = wfrom;
	}
	QImage fdnoir(wl_width,wl_height,QImage::Format_ARGB32);
	fdnoir.fill(Qt::black);
	fdnoir.save(wpathprojet + "/Manslide_fdnoir.jpg","JPEG");
	int reste_modulo;
	int nbre_transitions = 0;
	while ( i <= wto - 1 )
	{
		if ( i > 0 )
		{
			if ( i >= wfrom )
			{
				n = o - 1;
				wl_var_1 = "000000000";
				wl_var_2 = QString::number(n);
				wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
				wstartfile = wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg";
				fdnoir.load(wstartfile);
				fdnoir.save(wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg","JPEG",wl_qualite);
			}
			else
			{
				fdnoir.fill(Qt::black);
				fdnoir.save(wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg","JPEG");
			}
		}
		if ( table_photos[i][20] != "0" )
		{
			if ( table_photos[i][21].toInt() > 0 )
			{
				l = table_photos[i][21].toInt() * 25;
			}
			if ( i > 0 && ispreview == 0 )
			{
				m = (uint)(o - l);
			}
			else
			{
				m = (o - l);
			}
			k = (uint)(o);
			switch(table_photos[i][20].toInt())
			{
			case 1:
				wprogress = (uint)(100 / l);
				wstart = 0;
				wend = 100;
				break;
			case 2:
				wprogress = (wl_width / l) * -1;
				reste_modulo = wl_width % l;
				o = o + (reste_modulo / wprogress);
				wstart = wl_width;
				break;
			case 3:
				wprogress = (uint)(wl_width / l);
				reste_modulo = wl_width % l;
				o = o + (reste_modulo / wprogress);
				wstart = wl_width * -1;
				break;
			case 4:
				wprogress = (uint)(wl_height / l);
				reste_modulo = wl_height % l;
				o = o + (reste_modulo / wprogress);
				wstart = wl_height * -1;
				break;
			case 5:
				wprogress = (wl_height / l) * -1;
				reste_modulo = wl_height % l;
				o = o + (reste_modulo / wprogress);
				wstart = wl_height;
				break;
			case 6:
				wprogress = (uint)(wl_height / l);
				reste_modulo = wl_height % l;
				o = o + (reste_modulo / wprogress);
				wstart = wl_height * -1;
				wprogress_2 = (wl_width / l) * -1;
				wstart_2 = wl_width;
				break;
			case 7:
				wprogress = (uint)(wl_height / l);
				reste_modulo = wl_height % l;
				o = o + (reste_modulo / wprogress);
				wstart = wl_height * -1;
				wprogress_2 = (uint)(wl_width / l);
				wstart_2 = wl_width * -1;
				break;
			case 8:
				wprogress = (wl_height / l) * -1;
				reste_modulo = wl_height % l;
				o = o + (reste_modulo / wprogress);
				wstart = wl_height;
				wprogress_2 = (wl_width / l) * -1;
				wstart_2 = wl_width;
				break;
			case 9:
				wprogress = (wl_height / l) * -1;
				reste_modulo = wl_height % l;
				o = o + (reste_modulo / wprogress);
				wstart = wl_height;
				wprogress_2 = (uint)(wl_width / l);
				wstart_2 = wl_width * -1;
				break;
			case 10:
				wprogress = (uint)(wl_width / l);
				reste_modulo = wl_width % l;
				o = o + (reste_modulo / wprogress);
				wstart = wl_width;
				wstart_2 = wl_width * -1;
				break;
			case 11:
				wprogress = (uint)(wl_height / l);
				reste_modulo = wl_height % l;
				o = o + (reste_modulo / wprogress);
				wstart = wl_height;
				wstart_2 = wl_height * -1;
				break;
			case 12:
				wprogress = (uint)((wl_width / 2) / l);
				reste_modulo = (wl_width / 2) % l;
				o = o + (reste_modulo / wprogress);
				wstart = wl_width;
				wstart_2 = (wl_width / 2) * -1;
				break;
			case 13:
				wprogress = (uint)((wl_height / 2) / l);
				reste_modulo = (wl_height / 2) % l;
				o = o + (reste_modulo / wprogress);
				wstart = wl_height;
				wstart_2 = (wl_height / 2) * -1;
				break;
			case 14:
				wprogress = (uint)(wl_width / l);
				reste_modulo = (wl_width / 2) % l;
				o = o + (reste_modulo / wprogress);
				wstart = wl_width;
				wstart_2 = -220;
				break;
			case 15:
			case 16:
			case 17:
			case 18:
			case 19:
			case 20:
			case 21:
			case 22:
			case 23:
			case 24:
				if ( l < 100 )
				{
					wprogress = (uint)(100 / l);
					reste_modulo = 100 % l;
					o = o + (reste_modulo / wprogress);
				}
				else
				{
					wprogress = 1;
				}
				wstart = 100;
				break;
			}
			while ( m <= o )
			{
				switch(table_photos[i][20].toInt())
				{
				case 1:
					// *** Fondu enchaine ***
					if ( i > 0 )
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg\"";
					}
					else
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdnoir.jpg\"";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = "\"" + wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg\"";
					//
					out << "composite -dissolve " + QString::number(wend) + "x" + QString::number(wstart) + " " + wstartfile + " " + wendfile + " " + wendfile << endl;
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart = wstart + wprogress;
					wend = wend - wprogress;
					break;
				case 2:
					// *** Recouvrement droite ***
					if ( i > 0 )
					{
						wstartfile = wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg";
					}
					else
					{
						wstartfile = wpathprojet + "/Manslide_fdnoir.jpg";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg";
					//
					wl_img_2.load(wstartfile);
					wl_img_4.load(wendfile);
					//
        				p.begin(&wl_img_2);
					p.drawImage(wstart, 0, wl_img_4, 0, 0, -1, -1, Qt::AutoColor );
					p.end();
					wl_img_2.save(wendfile,"JPEG",wl_qualite);
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart = wstart + wprogress;
					break;
				case 3:
					// *** Recouvrement gauche ***
					if ( i > 0 )
					{
						wstartfile = wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg";
					}
					else
					{
						wstartfile = wpathprojet + "/Manslide_fdnoir.jpg";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg";
					//
					wl_img_2.load(wstartfile);
					wl_img_4.load(wendfile);
					//
        				p.begin(&wl_img_2);
					p.drawImage(wstart, 0, wl_img_4, 0, 0, -1, -1, Qt::AutoColor );
					p.end();
					wl_img_2.save(wendfile,"JPEG",wl_qualite);
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart = wstart + wprogress;
					break;
				case 4:
					// *** Recouvrement haut ***
					if ( i > 0 )
					{
						wstartfile = wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg";
					}
					else
					{
						wstartfile = wpathprojet + "/Manslide_fdnoir.jpg";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg";
					//
					wl_img_2.load(wstartfile);
					wl_img_4.load(wendfile);
					//
        				p.begin(&wl_img_2);
					p.drawImage(0, wstart, wl_img_4, 0, 0, -1, -1, Qt::AutoColor );
					p.end();
					wl_img_2.save(wendfile,"JPEG",wl_qualite);
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart = wstart + wprogress;
					break;
				case 5:
					// *** Recouvrement bas ***
					if ( i > 0 )
					{
						wstartfile = wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg";
					}
					else
					{
						wstartfile = wpathprojet + "/Manslide_fdnoir.jpg";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg";
					//
					wl_img_2.load(wstartfile);
					wl_img_4.load(wendfile);
					//
        				p.begin(&wl_img_2);
					p.drawImage(0, wstart, wl_img_4, 0, 0, -1, -1, Qt::AutoColor );
					p.end();
					wl_img_2.save(wendfile,"JPEG",wl_qualite);
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart = wstart + wprogress;
					break;
				case 6:
				case 7:
				case 8:
				case 9:
					// *** Recouvrement coins ***
					if ( i > 0 )
					{
						wstartfile = wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg";
					}
					else
					{
						wstartfile = wpathprojet + "/Manslide_fdnoir.jpg";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg";
					//
					wl_img_2.load(wstartfile);
					wl_img_4.load(wendfile);
					//
        				p.begin(&wl_img_2);
					p.drawImage(wstart_2, wstart, wl_img_4, 0, 0, -1, -1, Qt::AutoColor );
					p.end();
					wl_img_2.save(wendfile,"JPEG",wl_qualite);
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart_2 = wstart_2 + wprogress_2;
					wstart = wstart + wprogress;
					break;
				case 10:
					// *** Transition double horizontal ***
					if ( i > 0 )
					{
						wstartfile = wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg";
					}
					else
					{
						wstartfile = wpathprojet + "/Manslide_fdnoir.jpg";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg";
					//
					wl_img_2.load(wstartfile);
					wl_img_4.load(wendfile);
					//
        				p.begin(&wl_img_2);
					p.drawImage(wstart, 0, wl_img_4, 0, 0, -1, (wl_height / 2), Qt::AutoColor );
					p.drawImage(wstart_2, (wl_height / 2), wl_img_4, 0, (wl_height / 2), -1, -1, Qt::AutoColor );
					p.end();
					wl_img_2.save(wendfile,"JPEG",wl_qualite);
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart_2 = wstart_2 + wprogress;
					wstart = wstart - wprogress;
					break;
				case 11:
					// *** Transition double vertical ***
					if ( i > 0 )
					{
						wstartfile = wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg";
					}
					else
					{
						wstartfile = wpathprojet + "/Manslide_fdnoir.jpg";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg";
					//
					wl_img_2.load(wstartfile);
					wl_img_4.load(wendfile);
					//
        				p.begin(&wl_img_2);
					p.drawImage(0, wstart, wl_img_4, 0, 0, (wl_width / 2), -1, Qt::AutoColor );
					p.drawImage((wl_width / 2), wstart_2, wl_img_4, (wl_width / 2), 0, -1, -1, Qt::AutoColor );
					p.end();
					wl_img_2.save(wendfile,"JPEG",wl_qualite);
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart_2 = wstart_2 + wprogress;
					wstart = wstart - wprogress;
					break;
				case 12:
					// *** Rideaux vertical ***
					if ( i > 0 )
					{
						wstartfile = wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg";
					}
					else
					{
						wstartfile = wpathprojet + "/Manslide_fdnoir.jpg";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg";
					//
					wl_img_2.load(wstartfile);
					wl_img_4.load(wendfile);
					//
        				p.begin(&wl_img_2);
					p.drawImage(wstart_2, 0, wl_img_4, 0, 0, (wl_width / 2), -1, Qt::AutoColor );
					p.drawImage(wstart, 0, wl_img_4, (wl_width / 2), 0, -1, -1, Qt::AutoColor );
					p.end();
					wl_img_2.save(wendfile,"JPEG",wl_qualite);
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart_2 = wstart_2 + wprogress;
					wstart = wstart - wprogress;
					break;
				case 13:
					// *** Rideaux horizontal ***
					if ( i > 0 )
					{
						wstartfile = wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg";
					}
					else
					{
						wstartfile = wpathprojet + "/Manslide_fdnoir.jpg";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg";
					//
					wl_img_2.load(wstartfile);
					wl_img_4.load(wendfile);
					//
        				p.begin(&wl_img_2);
					p.drawImage(0, wstart_2, wl_img_4, 0, 0, -1, (wl_height / 2), Qt::AutoColor );
					p.drawImage(0, wstart, wl_img_4, 0, (wl_height / 2), -1, -1, Qt::AutoColor );
					p.end();
					wl_img_2.save(wendfile,"JPEG",wl_qualite);
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart_2 = wstart_2 + wprogress;
					wstart = wstart - wprogress;
					break;
				case 14:
					// *** Transition double bandes ***
					if ( i > 0 )
					{
						wstartfile = wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg";
					}
					else
					{
						wstartfile = wpathprojet + "/Manslide_fdnoir.jpg";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg";
					//
					wl_img_2.load(wstartfile);
					wl_img_4.load(wendfile);
					//
        				p.begin(&wl_img_2);
					p.drawImage(wstart, 0, wl_img_4, wstart, 0, 500, -1, Qt::AutoColor );
					p.drawImage(wstart_2, 0, wl_img_4, wstart_2, 0, 220, -1, Qt::AutoColor );
					p.end();
					wl_img_2.save(wendfile,"JPEG",wl_qualite);
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart_2 = wstart_2 + wprogress;
					wstart = wstart - wprogress;
					break;
				case 15:
					// *** LUMA ***
					if ( i > 0 )
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg\"";
					}
					else
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdnoir.jpg\"";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = "\"" + wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg\"";
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(m);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					woutfile = "\"" + wpathprojet + "/Trans_xxx_" + QString::number(i) + wl_var_1 + ".jpg\"";
					out << "convert \"" + QApplication::applicationDirPath() + "/Luma/luma_001.pgm\" -level " + QString::number(wstart) + "%,0%,1 \"" + wpathprojet + "/tmpluma.pgm\"" << endl;
					out << "composite " + wendfile + " " + wstartfile + " \"" + wpathprojet + "/tmpluma.pgm\" " + wendfile << endl;
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart = wstart - wprogress;
					break;
				case 16:
					// *** LUMA ***
					if ( i > 0 )
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg\"";
					}
					else
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdnoir.jpg\"";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = "\"" + wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg\"";
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(m);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					woutfile = "\"" + wpathprojet + "/Trans_xxx_" + QString::number(i) + wl_var_1 + ".jpg\"";
					out << "convert \"" + QApplication::applicationDirPath() + "/Luma/luma_002.pgm\" -level " + QString::number(wstart) + "%,0%,1 \"" + wpathprojet + "/tmpluma.pgm\"" << endl;
					out << "composite " + wendfile + " " + wstartfile + " \"" + wpathprojet + "/tmpluma.pgm\" " + wendfile << endl;
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart = wstart - wprogress;
					break;
				case 17:
					// *** LUMA ***
					if ( i > 0 )
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg\"";
					}
					else
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdnoir.jpg\"";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = "\"" + wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg\"";
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(m);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					woutfile = "\"" + wpathprojet + "/Trans_xxx_" + QString::number(i) + wl_var_1 + ".jpg\"";
					out << "convert \"" + QApplication::applicationDirPath() + "/Luma/luma_003.pgm\" -level " + QString::number(wstart) + "%,0%,1 \"" + wpathprojet + "/tmpluma.pgm\"" << endl;
					out << "composite " + wendfile + " " + wstartfile + " \"" + wpathprojet + "/tmpluma.pgm\" " + wendfile << endl;
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart = wstart - wprogress;
					break;
				case 18:
					// *** LUMA ***
					if ( i > 0 )
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg\"";
					}
					else
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdnoir.jpg\"";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = "\"" + wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg\"";
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(m);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					woutfile = "\"" + wpathprojet + "/Trans_xxx_" + QString::number(i) + wl_var_1 + ".jpg\"";
					out << "convert \"" + QApplication::applicationDirPath() + "/Luma/luma_004.pgm\" -level " + QString::number(wstart) + "%,0%,1 \"" + wpathprojet + "/tmpluma.pgm\"" << endl;
					out << "composite " + wendfile + " " + wstartfile + " \"" + wpathprojet + "/tmpluma.pgm\" " + wendfile << endl;
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart = wstart - wprogress;
					break;
				case 19:
					// *** LUMA ***
					if ( i > 0 )
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg\"";
					}
					else
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdnoir.jpg\"";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = "\"" + wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg\"";
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(m);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					woutfile = "\"" + wpathprojet + "/Trans_xxx_" + QString::number(i) + wl_var_1 + ".jpg\"";
					out << "convert \"" + QApplication::applicationDirPath() + "/Luma/luma_005.pgm\" -level " + QString::number(wstart) + "%,0%,1 \"" + wpathprojet + "/tmpluma.pgm\"" << endl;
					out << "composite " + wendfile + " " + wstartfile + " \"" + wpathprojet + "/tmpluma.pgm\" " + wendfile << endl;
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart = wstart - wprogress;
					break;
				case 20:
					// *** LUMA ***
					if ( i > 0 )
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg\"";
					}
					else
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdnoir.jpg\"";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = "\"" + wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg\"";
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(m);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					woutfile = "\"" + wpathprojet + "/Trans_xxx_" + QString::number(i) + wl_var_1 + ".jpg\"";
					out << "convert \"" + QApplication::applicationDirPath() + "/Luma/luma_006.pgm\" -level " + QString::number(wstart) + "%,0%,1 \"" + wpathprojet + "/tmpluma.pgm\"" << endl;
					out << "composite " + wendfile + " " + wstartfile + " \"" + wpathprojet + "/tmpluma.pgm\" " + wendfile << endl;
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart = wstart - wprogress;
					break;
				case 21:
					// *** LUMA ***
					if ( i > 0 )
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg\"";
					}
					else
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdnoir.jpg\"";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = "\"" + wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg\"";
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(m);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					woutfile = "\"" + wpathprojet + "/Trans_xxx_" + QString::number(i) + wl_var_1 + ".jpg\"";
					out << "convert \"" + QApplication::applicationDirPath() + "/Luma/luma_007.pgm\" -level " + QString::number(wstart) + "%,0%,1 \"" + wpathprojet + "/tmpluma.pgm\"" << endl;
					out << "composite " + wendfile + " " + wstartfile + " \"" + wpathprojet + "/tmpluma.pgm\" " + wendfile << endl;
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart = wstart - wprogress;
					break;
				case 22:
					// *** LUMA ***
					if ( i > 0 )
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg\"";
					}
					else
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdnoir.jpg\"";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = "\"" + wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg\"";
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(m);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					woutfile = "\"" + wpathprojet + "/Trans_xxx_" + QString::number(i) + wl_var_1 + ".jpg\"";
					out << "convert \"" + QApplication::applicationDirPath() + "/Luma/luma_008.pgm\" -level " + QString::number(wstart) + "%,0%,1 \"" + wpathprojet + "/tmpluma.pgm\"" << endl;
					out << "composite " + wendfile + " " + wstartfile + " \"" + wpathprojet + "/tmpluma.pgm\" " + wendfile << endl;
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart = wstart - wprogress;
					break;
				case 23:
					// *** LUMA ***
					if ( i > 0 )
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg\"";
					}
					else
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdnoir.jpg\"";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = "\"" + wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg\"";
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(m);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					woutfile = "\"" + wpathprojet + "/Trans_xxx_" + QString::number(i) + wl_var_1 + ".jpg\"";
					out << "convert \"" + QApplication::applicationDirPath() + "/Luma/luma_009.pgm\" -level " + QString::number(wstart) + "%,0%,1 \"" + wpathprojet + "/tmpluma.pgm\"" << endl;
					out << "composite " + wendfile + " " + wstartfile + " \"" + wpathprojet + "/tmpluma.pgm\" " + wendfile << endl;
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart = wstart - wprogress;
					break;
				case 24:
					// *** LUMA ***
					if ( i > 0 )
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdlastphoto" + QString::number(i) + ".jpg\"";
					}
					else
					{
						wstartfile = "\"" + wpathprojet + "/Manslide_fdnoir.jpg\"";
					}
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(k);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					wendfile = "\"" + wpathprojet + "/Slide_xxx_" + wl_var_1 + ".jpg\"";
					//
					wl_var_1 = "000000000";
					wl_var_2 = QString::number(m);
					wl_var_1.replace( 9 - wl_var_2.length(), wl_var_2.length(), wl_var_2);
					woutfile = "\"" + wpathprojet + "/Trans_xxx_" + QString::number(i) + wl_var_1 + ".jpg\"";
					out << "convert \"" + QApplication::applicationDirPath() + "/Luma/luma_010.pgm\" -level " + QString::number(wstart) + "%,0%,1 \"" + wpathprojet + "/tmpluma.pgm\"" << endl;
					out << "composite " + wendfile + " " + wstartfile + " \"" + wpathprojet + "/tmpluma.pgm\" " + wendfile << endl;
					//
					out << "echo GIBPRG > /dev/stderr" << endl;
					//
					wstart = wstart - wprogress;
					break;
				}
				nbre_transitions++;
				m = m + 1;
				k = k + 1;
			}
		}
		if ( table_photos[i][20].toInt() > 1 )
		{
			o = o - (reste_modulo / wprogress);
		}
		o = o + (table_photos[i][18].toInt() * 25) + (table_photos[i][19].toInt() * 25) + (table_photos[i][16].toInt() * 25);
		i = i + 1;
	}
	if ( ispreview == 0 )
	{
        	out << "jpeg2yuv -f 25 -I p -l 1 -j \"" + wpathprojet + "/Slide_xxx_%09d.jpg\" | mpeg2enc -M " + wg_cpu + " -f 3 -b 10000 -n p -o \"" + wpathprojet + "/" + name_encoding->text() + "\"" << endl;
	}
	else
	{
		out << "jpeg2yuv -f 25 -I p -l 1 -j \"" + wpathprojet + "/Slide_xxx_%09d.jpg\" | mpeg2enc -M " + wg_cpu + " -f 3 -b 10000 -n p -o \"" + wpathprojet + "/MSpreview.mpg\"" << endl;
	}
	out << "rm -f Slide_xxx_*.jpg" << endl;
	out << "rm -f *.sh" << endl;

	myfic.close();
	//
	frame_ed3d->setGeometry(440,60,525,408);
	pntmygl->setGeometry(10,10,505,388);
	//
	if ( ispreview == 1 && isfirst == 0 )
	{
		wfrom = current_diapo - 1;
		table_photos[wfrom][1] = tmp_tab[0][1];
        	table_photos[wfrom][2] = tmp_tab[0][2];
        	table_photos[wfrom][3] = tmp_tab[0][3];
        	table_photos[wfrom][4] = tmp_tab[0][4];
        	table_photos[wfrom][5] = tmp_tab[0][5];
        	table_photos[wfrom][6] = tmp_tab[0][6];
        	table_photos[wfrom][18] = tmp_tab[0][18];
        	table_photos[wfrom][19] = tmp_tab[0][19];
        	table_photos[wfrom][16] = tmp_tab[0][16];
        	table_photos[wfrom][20] = tmp_tab[0][20];
	}
	//
	label_14->setText(tr("Encodage du diaporama ..."));
	pb_encode->setValue(0);
	pb_encode->setMaximum(wl_total_frame + nbre_transitions);
	QPixmap wl_pix_001(319,149);
	wl_pix_001.fill(Qt::black);
	QPixmap wl_pix_002 = QPixmap::grabWindow ( this->winId(), 340, 231, 319, 149);
	p.begin(&wl_pix_001);
	p.drawPixmap(0, 0, wl_pix_002, 0, 0, -1, -1 );
	p.drawPixmap(0, 0, gl_fond, 0, 0, -1, -1 );
	p.end();
	fond_encode->setPixmap(wl_pix_001);
	fond_encode->setGeometry(1,1,319,149);
	fond_encode->lower();
	frame_encode->setGeometry(339,230,321,151);
	frame_encode->show();
	frame_encode->raise();
	poursuite = 0;
// *** Lancement du process de generation ***
	QString program = "bash";
       	QStringList arguments;
	//
       	arguments << wpathprojet + "/encode.sh";
       	myprocess_2.start( program, arguments );
}

void mainfrm::lecture_console_encoding()
{
	int j;
	QByteArray newData = myprocess_2.readAllStandardError();
	QString wl_var_1 = QString::fromLocal8Bit(newData);
        j = wl_var_1.indexOf("Frame", 0);
        if ( j != -1 )
        {
		poursuite = poursuite + 1;
        	pb_encode->setValue(poursuite);
        }
        j = wl_var_1.indexOf("GIBPRG", 0);
        if ( j != -1 )
        {
		poursuite = poursuite + 1;
        	pb_encode->setValue(poursuite);
        }
}

void mainfrm::end_encoding(int, QProcess::ExitStatus)
{
	myprocess_2.terminate();
	// *** Calcul de la duree du diaporama ***
	int durdiap = 0;
	int i;
	int j;
	int l_start;
	int l_end;
	int z = 0;
	int tpsavant = 0;

	if ( ispreview == 1 )
	{
		if (current_diapo > 0)
		{
			i = current_diapo - 1;
		}
		else
		{
			i = current_diapo;
		}
		j = current_diapo + 1;
		l_start = i;
		l_end = j;
		durdiap = table_photos[current_diapo][18].toInt() + table_photos[current_diapo][19].toInt() + table_photos[current_diapo][16].toInt() + 1;
	}
	else
	{
		i = from_encoding->value() - 1;
		j = to_encoding->value() - 1;
		l_start = i;
		l_end = j;
		while ( i <= j )
		{
			durdiap = durdiap + table_photos[i][18].toInt() + table_photos[i][19].toInt() + table_photos[i][16].toInt();
			i = i + 1;
		}
		i = from_encoding->value() - 1;
	}
	j = 0;
	while ( j < i )
	{
		tpsavant = tpsavant + table_photos[j][18].toInt() + table_photos[j][19].toInt() + table_photos[j][16].toInt();
		j = j + 1;
	} 
	//
	z = 48000 * durdiap; 
	//
       	QFile myfic(wpathprojet + "/trtaudio.sh");

        if ( !myfic.open( QIODevice::WriteOnly ))
        {
		this->setEnabled(true);
		return;
	}
	else
	{
		QTextStream out(&myfic);
		out << "#!/bin/bash" << endl;
		out << "cd " + wpathprojet << endl;
		out << "dd if=/dev/zero bs=4 count=" << QString::number(z) << " | lame -b 128 -s 48 /dev/stdin silent.mp3" << endl;
		out << "sox silent.mp3 -t ogg silent.ogg" << endl;
		if ( zik_number > 0 )
		{
			float volume = (float)zik_volume->value() / (float)100;
			out << "sox \"" << table_zik[0][0] << "\" -S " << " -v " << QString::number(volume) << " -w -r 48000 " << wpathprojet + "/bandeson.ogg rate" << endl;

			// extrait et mixage de la partie concernee
			out << "sox bandeson.ogg -t ogg -c 2 extrait.ogg trim " << QString::number(tpsavant) << " " << QString::number(durdiap) << endl;
			out << "sox silent.ogg -t ogg -c 2 extrait2.ogg trim 0 " << QString::number(durdiap) << endl;
			out << "soxmix extrait.ogg extrait2.ogg -t ogg melange.ogg" << endl;
			out << "sox silent.ogg -t ogg -c 2 fin.ogg trim " << QString::number(tpsavant) << endl;
			out << "sox melange.ogg fin.ogg  bandeson.ogg" << endl;
			out << "rm -f extrait.ogg" << endl;
			out << "rm -f extrait2.ogg" << endl;
			out << "rm -f melange.ogg" << endl;
		}
		else
		{
			out << "sox silent.ogg -t ogg bandeson.ogg" << endl;
		}
		out << "rm -f Manslide_fdlastphoto*.jpg" << endl;
		out << "rm -f Manslide_fdnoir.jpg" << endl;
		//
		i = l_start;
		int dur_cur_diapo = 0;
		int pos_flux = 0;
		int stamppiege = 0;
		while ( i <= l_end )
		{
			if ( ispreview == 1 && i == l_start && l_start != 0 )
			{
				stamppiege = 2;
			}
			if ( table_photos[i][24] != "" && stamppiege == 0 )
			{
				dur_cur_diapo = table_photos[i][18].toInt() + table_photos[i][19].toInt() + table_photos[i][16].toInt();
				out << "sox bandeson.ogg -t ogg -c 2 extrait.ogg trim " << QString::number(pos_flux) << " " << QString::number(dur_cur_diapo) << endl;
				out << "sox \"" << table_photos[i][24] << "\" -t ogg -c 2 -w -r 48000 extrait2.ogg trim 0 " << QString::number(dur_cur_diapo) << " rate" << endl;
				out << "soxmix extrait.ogg extrait2.ogg -t ogg melange.ogg" << endl;
				if ( pos_flux > 0 )
				{
					out << "sox bandeson.ogg -t ogg -c 2 debut.ogg trim 0:0:0.0 " << QString::number(pos_flux) << endl;
				}
				out << "sox bandeson.ogg -t ogg -c 2 fin.ogg trim " << QString::number(pos_flux + dur_cur_diapo) << endl;
				if ( pos_flux > 0 )
				{
					out << "sox debut.ogg melange.ogg fin.ogg  bandeson.ogg" << endl;
				}
				else
				{
					out << "sox melange.ogg fin.ogg  bandeson.ogg" << endl;
				}
				out << "rm -f extrait.ogg" << endl;
				out << "rm -f extrait2.ogg" << endl;
				out << "rm -f melange.ogg" << endl;
				out << "rm -f debut.ogg" << endl;
				out << "rm -f fin.ogg" << endl;
			}
			if ( stamppiege == 2 )
			{
				pos_flux = pos_flux + 1;
				stamppiege = 0;
			}
			else
			{
				pos_flux = pos_flux + table_photos[i][18].toInt() + table_photos[i][19].toInt() + table_photos[i][16].toInt();
			}
			i = i + 1;
		}
		//
		if ( ispreview == 0 )
		{
			if ( zik_number > 0 )
			{
				if ( wfadein->isChecked() == true )
				{
					if ( wfadeout->isChecked() == true )
					{
						out << "sox bandeson.ogg tmpbdson.ogg fade t 2.5 " << QString::number(durdiap) << " 2.5" << endl;
						out << "sox tmpbdson.ogg -t wav  bandeson.wav" << endl;
					}
					else
					{
						out << "sox bandeson.ogg tmpbdson.ogg fade t 2.5 " << QString::number(durdiap) << " 0" << endl;
						out << "sox tmpbdson.ogg -t wav  bandeson.wav" << endl;
					}
				}
				else
				{
					out << "sox bandeson.ogg tmpbdson.ogg fade t 0 " << QString::number(durdiap) << " 2.5" << endl;
					out << "sox tmpbdson.ogg -t wav  bandeson.wav" << endl;
				}
			}
			else
			{
				out << "sox bandeson.ogg -t wav  bandeson.wav" << endl;
			}
		}
		else
		{
			out << "sox bandeson.ogg -t wav  bandeson.wav" << endl;
		}
		out << "rm -f bandeson.ogg" << endl;
		out << "rm -f extrait.ogg" << endl;
		out << "rm -f extrait2.ogg" << endl;
		out << "rm -f silent.ogg" << endl;
		out << "rm -f silent.mp3" << endl;
		out << "exit";
		myfic.close();
		//
		label_14->setText(tr("Encodage de l'audio ..."));
		pb_encode->setValue(0);
		pb_encode->setMaximum(100);
		// *** Lancement du process de generation de l'audio ***
		QString program = "bash";
		QStringList arguments;
       		arguments << wpathprojet + "/trtaudio.sh";
		myprocess_3.start( program, arguments );
	}
}

void mainfrm::end_encoding_audio(int, QProcess::ExitStatus)
{
	myprocess_3.terminate();
	label_14->setText(tr("Finalisation du projet ..."));
       	QFile myfic(wpathprojet + "/audio.sh");

        if ( !myfic.open( QIODevice::WriteOnly ))
        {
		this->setEnabled(true);
		return;
	}
	else
	{
		QTextStream out(&myfic);
		out << "#!/bin/bash" << endl;
		out << "cd " + wpathprojet << endl;
		out << "mp2enc -r 48000 -o bandeson.mpa < bandeson.wav" << endl;
		if (ispreview == 0)
		{
			out << "mplex -f 8 -v 2 -o tmpgen.mpg \"" + name_encoding->text() + "\" bandeson.mpa" << endl;
			out << "mv -f tmpgen.mpg \"" + path_out_render->text() + "/" + name_encoding->text() + "\"" << endl;
		}
		else
		{
			out << "mplex -f 8 -v 2 -o tmpgen.mpg \"MSpreview.mpg\" bandeson.mpa" << endl;
			out << "mv -f tmpgen.mpg \"MSpreview.mpg\"" << endl;
		}
		
		out << "rm -f bandeson.mpa" << endl;
		out << "rm -f bandeson.wav" << endl;
		out << "rm -f fin.ogg" << endl;
		out << "rm -f trtaudio.sh" << endl;
		out << "rm -f audio.sh" << endl;
		myfic.close();
		// *** Lancement du process de generation de l'audio ***
		QString program = "bash";
       		QStringList arguments;
       		arguments << wpathprojet + "/audio.sh";
		myprocess_4.start( program, arguments );
	}
}

void mainfrm::end_all_audio(int, QProcess::ExitStatus)
{
	myprocess_4.terminate();
	fin_fin_encoding();
}

void mainfrm::lecture_console_out_audio_encoding()
{
	QByteArray newData = myprocess_3.readAllStandardError();
	QString wl_var_1 = QString::fromLocal8Bit(newData);
        int i = wl_var_1.indexOf("%", 0);
        if ( i != -1 )
        {
		int valueprog;
		int j = i;
		while ( wl_var_1.mid(i,1) != " " && i > 0 )
		{
			i = i - 1;
		}
		if ( i > 0 )
		{
			valueprog = wl_var_1.mid(i + 1, j - (i + 3)).toInt();
		}
		pb_encode->setValue(valueprog);
	}
}

void mainfrm::fin_fin_encoding()
{
	QString program;
	QStringList arguments;

	if ( combocodec->currentIndex() == 0 || ispreview == 1)
	{
		if ( ispreview == 0 )
		{
			this->setEnabled(true);
			M_BT_EXPORT->setDisabled(true);
		}
		else
		{
			this->setEnabled(true);
			M_BT_EXPORT->setEnabled(true);
		}
		frame_encode->hide();
		contain_timeline->setEnabled(true);
		pb_img_magick->setMaximum(100);
		label_14->setText(tr("Creation du diaporama ..."));
		if ( ispreview == 0 )
		{
			QMessageBox::information(this, "Manslide", tr("Creation du diaporama terminee avec succes"));
			int result = QMessageBox::information(this, "Manslide", tr("Voulez vous visualiser le resultat ?"), tr("Oui"), tr("Non"), 0, 1 );
			if (result == 0)
			{
				program = wg_player;
       				arguments << path_out_render->text() + "/" + name_encoding->text();
       				myprocess_6.start( program, arguments );
			}
		}
		else
		{
			program = wg_player;
       			arguments << wpathprojet + "/MSpreview.mpg";
       			myprocess_6.start( program, arguments );
		}
	}
	else
	{
		pb_encode->setValue(0);
		pb_encode->setMaximum(100);
		if ( combocodec->currentIndex() == 1 )
		{
      			QFile myfic(wpathprojet + "/encoding.sh");
		        if ( !myfic.open( QIODevice::WriteOnly ))
        		{
				return;
			}
			else
			{
				label_14->setText(tr("Encodage au format XVID ..."));
				QTextStream out(&myfic);
				out << "#!/bin/bash" << endl;
				out << "cd " + path_out_render->text() << endl;
				out << "rm -f " + wpathprojet + "/audio.sh" << endl;
				out << "mencoder -oac mp3lame -ovc xvid -lameopts preset=standard:fast -xvidencopts pass=1 -o GIBOTMP.ZMPG " + name_encoding->text() << endl;
				out << "mv -f GIBOTMP.ZMPG " + name_encoding->text() << endl; 
				out << "rm -f *.log" << endl; 
				out << "rm -f " + wpathprojet + "/encoding.sh" << endl;
				myfic.close();
				program = "bash";
				arguments << wpathprojet + "/encoding.sh";
       				myprocess_7.start( program, arguments );
			}
		}
		else
		{
			if ( combocodec->currentIndex() == 2 )
			{
      				QFile myfic(wpathprojet + "/encoding.sh");
		        	if ( !myfic.open( QIODevice::WriteOnly ))
        			{
					return;
				}
				else
				{
					label_14->setText(tr("Encodage au format DV AVI ..."));
					QTextStream out(&myfic);
					out << "#!/bin/bash" << endl;
					out << "cd " + path_out_render->text() << endl;
					out << "rm -f " + wpathprojet + "/audio.sh" << endl;
					out << "mencoder -vf scale=720:576 -ovc libdv -oac pcm -o GIBOTMP.ZMPG " + name_encoding->text() << endl;
					out << "mv -f GIBOTMP.ZMPG " + name_encoding->text() << endl;
					out << "rm -f *.log" << endl; 
					out << "rm -f " + wpathprojet + "/encoding.sh" << endl;
					myfic.close();
					program = "bash";
					arguments << wpathprojet + "/encoding.sh";
       					myprocess_7.start( program, arguments );
				}
			}
		}
	}
}

void mainfrm::end_convert_video(int, QProcess::ExitStatus)
{
	pb_encode->setValue(100);
	QString program;
	QStringList arguments;
	frame_encode->hide();
	contain_timeline->setEnabled(true);
	pb_img_magick->setMaximum(100);
	this->setEnabled(true);
	param_encoding->show();
	param_encoding->raise();
	label_14->setText(tr("Creation du diaporama ..."));
	QMessageBox::information(this, "Manslide", tr("Creation du diaporama terminee avec succes"));
	int result = QMessageBox::information(this, "Manslide", tr("Voulez vous visualiser le resultat ?"), tr("Oui"), tr("Non"), 0, 1 );
	if (result == 0)
	{
		program = wg_player;
      		arguments << path_out_render->text() + "/" + name_encoding->text();
		myprocess_6.start( program, arguments );
	}
}

void mainfrm::lecture_convert_video()
{
    	// ************************************
    	// *** Lecture de la sortie console ***   
    	// ************************************
	QByteArray newData = myprocess_7.readAllStandardOutput();
	QString wl_var_1 = QString::fromLocal8Bit(newData);
        int i = wl_var_1.indexOf("%", 0);
        if ( i != -1 )
        {
		QString wl_tmp_01;
		int valueprog;
       		wl_tmp_01 = wl_var_1.mid((i - 2),2);
       		valueprog = wl_tmp_01.toInt();
       		pb_encode->setValue(valueprog);
	}
}

void mainfrm::f_generer_diapo()
{
	if ( name_encoding->text() == "" )
	{
 		QMessageBox::information(this, "Manslide", tr("Vous devez choisir un titre pour votre diaporama.\n"));
	}
	else
	{
		if ( path_out_render->text() != "" )
		{
			if ( from_encoding->value() > to_encoding->value() )
			{
				QMessageBox::information(this, "Manslide", tr("La diapositive de fin doit etre situee apres la diapositive de debut.\n"));
			}
			else
			{
				ispreview = 0;
				param_encoding->hide();
				frame_ed3d->setGeometry(130,44,740,596);
				pntmygl->setGeometry(10,10,720,576);
				frame_ed3d->raise();
				this->setDisabled(true);
				QTimer::singleShot(200, this, SLOT(f_render()));
			}
		}
		else
		{
			QMessageBox::information(this, "Manslide", tr("Vous devez choir le dossier de destination pour votre diaporama.\n"));
		}
	}
}

void mainfrm::f_gris()
{
	if ( nbre_photos >= 0 )
	{
		QString program = "convert";
        	QStringList arguments;
		//
		outfilename = table_photos[current_diapo][0];
		//
        	arguments << "-colorspace" << "GRAY" << "-monitor" << wpathprojet + "/" + table_photos[current_diapo][0] << wpathprojet + "/tmpphoto.png";
        	myprocess_1.start( program, arguments );
		this->setDisabled(true);
	}
}

void mainfrm::f_paint()
{
	if ( nbre_photos >= 0 )
	{
		QString program = "convert";
        	QStringList arguments;
		//
		outfilename = table_photos[current_diapo][0];
		//
        	arguments << "-paint" << QString::number(1) << "-monitor" << wpathprojet + "/" + table_photos[current_diapo][0] << wpathprojet + "/tmpphoto.png";
        	myprocess_1.start( program, arguments );
		this->setDisabled(true);
	}
}

void mainfrm::f_edge()
{
	if ( nbre_photos >= 0 )
	{
		QString program = "convert";
        	QStringList arguments;
		//
		outfilename = table_photos[current_diapo][0];
		//
        	arguments << "-edge" << QString::number(1) << "-monitor" << wpathprojet + "/" + table_photos[current_diapo][0] << wpathprojet + "/tmpphoto.png";
        	myprocess_1.start( program, arguments );
		this->setDisabled(true);
	}
}

void mainfrm::f_rneg()
{
	if ( nbre_photos >= 0 )
	{
		QString program = "convert";
        	QStringList arguments;
		//
		outfilename = table_photos[current_diapo][0];
		//
        	arguments << "-rotate";
		arguments << "-90";
		arguments << "-monitor"; 
		arguments << wpathprojet + "/" + table_photos[current_diapo][0] << wpathprojet + "/tmpphoto.png";
        	myprocess_1.start( program, arguments );
		this->setDisabled(true);
	}
}

void mainfrm::f_rpos()
{
	if ( nbre_photos >= 0 )
	{
		QString program = "convert";
        	QStringList arguments;
		//
		outfilename = table_photos[current_diapo][0];
		//
        	arguments << "-rotate";
		arguments << "90";
		arguments << "-monitor"; 
		arguments << wpathprojet + "/" + table_photos[current_diapo][0] << wpathprojet + "/tmpphoto.png";
        	myprocess_1.start( program, arguments );
		this->setDisabled(true);
	}
}

void mainfrm::f_fade()
{
	if ( nbre_photos >= 0 )
	{
		QString program = "convert";
        	QStringList arguments;
		//
		outfilename = table_photos[current_diapo][0];
		//
        	arguments << "-vignette";
		arguments << "80x50";
		arguments << "-monitor"; 
		arguments << wpathprojet + "/" + table_photos[current_diapo][0] << wpathprojet + "/tmpphoto.png";
        	myprocess_1.start( program, arguments );
		this->setDisabled(true);
	}
}

void mainfrm::f_emboss()
{
	if ( nbre_photos >= 0 )
	{
		QString program = "convert";
        	QStringList arguments;
		//
		outfilename = table_photos[current_diapo][0];
		//
        	arguments << "-emboss" << QString::number(10) << "-monitor" << wpathprojet + "/" + table_photos[current_diapo][0] << wpathprojet + "/tmpphoto.png";
        	myprocess_1.start( program, arguments );
		this->setDisabled(true);
	}
}

void mainfrm::f_sharpen()
{
	if ( nbre_photos >= 0 )
	{
		QString program = "convert";
        	QStringList arguments;
		//
		outfilename = table_photos[current_diapo][0];
		//
        	arguments << "-sharpen" << QString::number(10) << "-monitor" << wpathprojet + "/" + table_photos[current_diapo][0] << wpathprojet + "/tmpphoto.png";
        	myprocess_1.start( program, arguments );
		this->setDisabled(true);
	}
}

void mainfrm::f_blur()
{
	if ( nbre_photos >= 0 )
	{
		QString program = "convert";
        	QStringList arguments;
		//
		outfilename = table_photos[current_diapo][0];
		//
        	arguments << "-blur" << QString::number(10) << "-monitor" << wpathprojet + "/" + table_photos[current_diapo][0] << wpathprojet + "/tmpphoto.png";
        	myprocess_1.start( program, arguments );
		this->setDisabled(true);
	}
}

void mainfrm::f_negate()
{
	if ( nbre_photos >= 0 )
	{
		QString program = "convert";
        	QStringList arguments;
		//
		outfilename = table_photos[current_diapo][0];
		//
        	arguments << "-negate" << "-monitor" << wpathprojet + "/" + table_photos[current_diapo][0] << wpathprojet + "/tmpphoto.png";
        	myprocess_1.start( program, arguments );
		this->setDisabled(true);
	}
}

void mainfrm::f_sepia()
{
	if ( nbre_photos >= 0 )
	{
		QString program = "convert";
        	QStringList arguments;
		//
		outfilename = table_photos[current_diapo][0];
		//
        	arguments << "-sepia-tone" << "80%" << "-monitor" << wpathprojet + "/" + table_photos[current_diapo][0] << wpathprojet + "/tmpphoto.png";
        	myprocess_1.start( program, arguments );
		this->setDisabled(true);
	}
}

void mainfrm::f_pcontraste()
{
	if ( nbre_photos >= 0 )
	{
		QString program = "convert";
        	QStringList arguments;
		//
		outfilename = table_photos[current_diapo][0];
		//
        	arguments << "-contrast" << "-monitor" << wpathprojet + "/" + table_photos[current_diapo][0] << wpathprojet + "/tmpphoto.png";
        	myprocess_1.start( program, arguments );
		this->setDisabled(true);
	}
}

void mainfrm::f_mcontraste()
{
	if ( nbre_photos >= 0 )
	{
		QString program = "convert";
        	QStringList arguments;
		//
		outfilename = table_photos[current_diapo][0];
		//
        	arguments << "+contrast" << "-monitor" << wpathprojet + "/" + table_photos[current_diapo][0] << wpathprojet + "/tmpphoto.png";
        	myprocess_1.start( program, arguments );
		this->setDisabled(true);
	}
}

void mainfrm::lecture_console_magick()
{
	int j;
	QByteArray newData = myprocess_1.readAllStandardOutput();
	QString wl_var_1 = QString::fromLocal8Bit(newData);
        j = wl_var_1.indexOf("%", 0);
        if ( j != -1 )
        {
		QString prcvalue;
		if ( wl_var_1.mid(j-3,1) == " " )
		{
			prcvalue = wl_var_1.mid(j-2,2);
		}
		else
		{
			prcvalue = wl_var_1.mid(j-3,3);
		}
        	pb_img_magick->setValue(prcvalue.toInt());
        }
}

void mainfrm::f_preview_originale()
{
	frame_preview_magick->hide();
	bt_play->setEnabled(true);
	bt_start->setEnabled(true);
	bt_end->setEnabled(true);
	frame_toptimeline->setEnabled(true);
	//
	frame_topmenu->setEnabled(true);
	menu_images->setEnabled(true);
	contain_timeline->setEnabled(true);
}

void mainfrm::f_preview_modifiee()
{
	QPixmap wl_pix_1;
	if ( wl_pix_1.load(wpathprojet + "/tmpphoto.png") == true )
	{
		wl_pix_1.save(wpathprojet + "/" + outfilename + ".png", "PNG", 75);
		table_photos[current_diapo][0] = outfilename + ".png";
		QLabel *mylabel;
		QIcon myicon = lst_transitions->itemIcon(lst_transitions->currentIndex());
		mylabel = table_pnt_img[current_diapo];
		QPixmap wl_pix_2(wg_diapositive);
		QPixmap wl_pix_3(83,63);
		if ( wl_pix_1.height() > wl_pix_1.width() )
		{
			wl_pix_3 = wl_pix_1.scaledToHeight ( 63, Qt::FastTransformation );
		}
		else
		{
			wl_pix_3 = wl_pix_1.scaledToWidth ( 83, Qt::FastTransformation );
		}
		QPainter p;
		p.begin(&wl_pix_2);
		p.drawPixmap(7 + ((83 - wl_pix_3.width()) / 2), 7, wl_pix_3, 0, 0, 83, 63 );
		if ( table_photos[current_diapo][24] != "" )
		{
			p.drawPixmap(2, 57, wg_comment, 0, 0, -1, -1 );
		}
		myicon.paint ( &p, 56, 45, 32, 24, Qt::AlignCenter, QIcon::Normal, QIcon::On );
		p.end();
		mylabel->setPixmap(wl_pix_2);
		frame_preview_magick->hide();
		bt_play->setEnabled(true);
		bt_start->setEnabled(true);
		bt_end->setEnabled(true);
		frame_toptimeline->setEnabled(true);
		//
		frame_topmenu->setEnabled(true);
		menu_images->setEnabled(true);
		contain_timeline->setEnabled(true);
		affichage_diapo();
	}
}

void mainfrm::end_process(int, QProcess::ExitStatus)
{
	frame_effets->hide();
	must_redraw = 1;
	myprocess_1.terminate();
	this->setEnabled(true);
	QPixmap wl_pix_1;
	if ( wl_pix_1.load(wpathprojet + "/tmpphoto.png") == true )
	{
		QPixmap wl_pix_2;
		wl_pix_2 = wl_pix_1.scaled ( 471, 376, Qt::KeepAspectRatio, Qt::FastTransformation);
		QPixmap wl_pix_3(471,376);
		//
		wl_pix_3.fill(Qt::white);
		QPainter p;
		p.begin(&wl_pix_3);
		p.drawPixmap(((471 - wl_pix_2.width())/2), ((376 - wl_pix_2.height())/2), wl_pix_2, 0, 0, -1, -1 );
		p.end();
		//
		QPixmap wl_pix_4;
		QPixmap wl_pix_5(471,376);
		wl_pix_5.fill(Qt::white);
		wl_pix_1.load(wpathprojet + "/" + table_photos[current_diapo][0]);
		wl_pix_4 = wl_pix_1.scaled ( 471, 376, Qt::KeepAspectRatio, Qt::FastTransformation);
		p.begin(&wl_pix_5);
		p.drawPixmap(((471 - wl_pix_4.width())/2), ((376 - wl_pix_4.height())/2), wl_pix_4, 0, 0, -1, -1 );
		p.end();
		p.begin(&wl_pix_3);
		p.drawPixmap(235, 0, wl_pix_5, 235, 0, -1, -1 );
		QColor mycolor(0,0,0);
		QColor mycolor2(255,255,255);
		QColor mycolor3(255,0,0);
		QBrush mybrush(mycolor,Qt::SolidPattern);
		p.fillRect( 15, ((376 - wl_pix_2.height())/2) + 10, 62, 15, mybrush );
		p.fillRect( 250, ((376 - wl_pix_2.height())/2) + 10, 62, 15, mybrush );
		p.setPen(mycolor2);
		p.drawText( 20, ((376 - wl_pix_2.height())/2)+ 21, tr("Modifiee") );
		p.drawText( 255, ((376 - wl_pix_2.height())/2) + 21, tr("Originale") );
		QPen mypen(Qt::DashLine);
		mypen.setColor(mycolor3);
		mypen.setWidth( 3 );
		p.setPen(mypen);
		p.drawLine( 234, 0, 234, 376 );
		p.end();

		preview_1->setPixmap(wl_pix_3);
		//
		frame_preview_magick->setGeometry(215,111,511,461);
		frame_preview_magick->show();
		frame_preview_magick->raise();
	}
	else
	{
		QMessageBox::information(this, "Manslide", tr("Erreur ImageMagick ..."));
	}
}

void mainfrm::f_hmirror()
{
	if ( nbre_photos >= 0 )
	{
		QImage wl_img_1(wpathprojet + "/" + table_photos[current_diapo][0]);
		QImage wl_img_2 = wl_img_1.mirrored ( true, false );
		//
		outfilename = table_photos[current_diapo][0];
		//
		wl_img_2.save(wpathprojet + "/tmpphoto.png","PNG",75);
		end_process(0,QProcess::NormalExit);
	}
}

void mainfrm::f_vmirror()
{
	if ( nbre_photos >= 0 )
	{
		QImage wl_img_1(wpathprojet + "/" + table_photos[current_diapo][0]);
		QImage wl_img_2 = wl_img_1.mirrored ( false, true );
		//
		outfilename = table_photos[current_diapo][0];
		//
		wl_img_2.save(wpathprojet + "/tmpphoto.png","PNG",75);
		end_process(0,QProcess::NormalExit);
	}
}

void mainfrm::supp_diapo()
{
	must_redraw = 0;
	if ( current_diapo == nbre_photos)
	{
		if ( nbre_photos > 0 )
		{
			delete table_pnt_img[current_diapo];
			current_diapo = current_diapo - 1;
			nbre_photos = nbre_photos - 1;
			affichage_diapo();
		}
		else
		{
			if ( nbre_photos == 0 )
			{
				delete table_pnt_img[current_diapo];
				current_diapo = current_diapo - 1;
				nbre_photos = nbre_photos - 1;
				QPixmap nullpix(791,571);
				QColor mycolor(0,0,0);
				nullpix.fill(mycolor);
				//
				bt_save_proj->setDisabled(true);
				bt_supprime_diapo->setDisabled(true);
				frame_ed3d->setDisabled(true);
				bt_play->setDisabled(true);
				bt_stop->setDisabled(true);
				bt_start->setDisabled(true);
				bt_end->setDisabled(true);
				param_diapo->setDisabled(true);
				bt_img_effects->setDisabled(true);
				bt_fond->setDisabled(true);
				bt_screenshot->setDisabled(true);
				frame_toptimeline->setDisabled(true);
				bt_start_new->setDisabled(true);
				plane->setChecked(true);
				group_support->setDisabled(true);
				img_selection->hide();
				pntmygl->iseffect = 0;
				//
				pntmygl->sl_charge_image(QApplication::applicationDirPath() + "$N$U$L$L",QApplication::applicationDirPath() + "$N$U$L$L");
				pntmygl->updateGL();
				stick_menu->setGeometry(10,7,98,32);
				frame_effets->hide();
				M_BT_PROJ->raise();
				menu_projet->setGeometry(0,50,391,471);
				menu_projet->show();
				menu_images->hide();
				frame_telecomm->hide();
				frame_zik->hide();
				frame_parameters->hide();
				param_encoding->hide();
				menu_projet->setFocus();
				M_BT_IMG->setEnabled(true);
				M_BT_IMG->raise();
			}
		}
	}
	else
	{
		delete table_pnt_img[current_diapo];
		QLabel *mylabel;
		QPoint mypoint;
		int i = current_diapo;
		int j = nbre_photos;
		while (i < j)
		{
			table_photos[i][0] = table_photos[i+1][0];
			table_photos[i][1] = table_photos[i+1][1];
			table_photos[i][2] = table_photos[i+1][2];
			table_photos[i][3] = table_photos[i+1][3];
			table_photos[i][4] = table_photos[i+1][4];
			table_photos[i][5] = table_photos[i+1][5];
			table_photos[i][6] = table_photos[i+1][6];
			table_photos[i][7] = table_photos[i+1][7];
			table_photos[i][8] = table_photos[i+1][8];
			table_photos[i][9] = table_photos[i+1][9];
			table_photos[i][10] = table_photos[i+1][10];
			table_photos[i][11] = table_photos[i+1][11];
			table_photos[i][12] = table_photos[i+1][12];
			table_photos[i][13] = table_photos[i+1][13];
			table_photos[i][14] = table_photos[i+1][14];
			table_photos[i][15] = table_photos[i+1][15];
			table_photos[i][16] = table_photos[i+1][16];
			table_photos[i][17] = table_photos[i+1][17];
			table_photos[i][18] = table_photos[i+1][18];
			table_photos[i][19] = table_photos[i+1][19];
			table_photos[i][20] = table_photos[i+1][20];
			table_photos[i][21] = table_photos[i+1][21];
			table_photos[i][22] = table_photos[i+1][22];
			table_photos[i][23] = table_photos[i+1][23];
			table_photos[i][24] = table_photos[i+1][24];
			table_pnt_img[i] = table_pnt_img[i+1];
			mylabel = table_pnt_img[i];
			mypoint = mylabel->pos();
			mylabel->setGeometry( mypoint.x() - 107, 0 , 97, 77);
			i = i + 1;
		}
		if ( current_diapo > 0 )
		{
			current_diapo = current_diapo - 1;
		}
		nbre_photos = nbre_photos - 1;
		affichage_diapo();
	}
	f_calcul_son();
	if ( ((nbre_photos + 1) * 110) - 740 > 0 )
	{
		scroll_timeline->setMaximum(((nbre_photos + 1) * 110) - 740);
	}
	else
	{
		scroll_timeline->setMaximum(0);
	}
}

void mainfrm::md_start()
{
	table_photos[current_diapo][1] = QString::number(pntmygl->deplacementX);
	table_photos[current_diapo][2] = QString::number(pntmygl->deplacementY);
	table_photos[current_diapo][3] = QString::number(pntmygl->zoom);
	table_photos[current_diapo][4] = QString::number(pntmygl->rotationX);
	table_photos[current_diapo][5] = QString::number(pntmygl->rotationY);
	table_photos[current_diapo][6] = QString::number(pntmygl->rotationZ);
	table_photos[current_diapo][13] = pntmygl->path_fond;
	if ( check_fog->isChecked() == true )
	{
		table_photos[current_diapo][14] = "1";
		table_photos[current_diapo][15] = QString::number(dial_opacity->value());
	}
	else
	{
		table_photos[current_diapo][14] = "0";
		table_photos[current_diapo][15] = "30";
	}
	table_photos[current_diapo][18] = QString::number(spindurpauselast->value());
	table_photos[current_diapo][19] = QString::number(spindurpausefirst->value());
	table_photos[current_diapo][22] = comboeffets->currentText();
	pntmygl->sl_mark_deb();
}

void mainfrm::md_fin()
{
	table_photos[current_diapo][7] = QString::number(pntmygl->deplacementX);
	table_photos[current_diapo][8] = QString::number(pntmygl->deplacementY);
	table_photos[current_diapo][9] = QString::number(pntmygl->zoom);
	table_photos[current_diapo][10] = QString::number(pntmygl->rotationX);
	table_photos[current_diapo][11] = QString::number(pntmygl->rotationY);
	table_photos[current_diapo][12] = QString::number(pntmygl->rotationZ);
	table_photos[current_diapo][13] = pntmygl->path_fond;
	if ( check_fog->isChecked() == true )
	{
		table_photos[current_diapo][14] = "1";
		table_photos[current_diapo][15] = QString::number(dial_opacity->value());
	}
	else
	{
		table_photos[current_diapo][14] = "0";
		table_photos[current_diapo][15] = "30";
	}
	table_photos[current_diapo][18] = QString::number(spindurpauselast->value());
	table_photos[current_diapo][19] = QString::number(spindurpausefirst->value());
	table_photos[current_diapo][22] = comboeffets->currentText();
	pntmygl->sl_mark_fin();
}

void mainfrm::load_photo()
{
	if ( nbre_photos < 400 )
	{
        	QStringList listsfile = QFileDialog::getOpenFileNames(
                	this,
                	tr("Ouvrir un fichier"),
                	path_photos_import,
                	"Images (*.jpg *.JPG *.jpeg *.JPEG *.png *.PNG)");
        	if ( listsfile.empty() == true )
        	{
        	}
        	else
        	{
			int nbre_new = 0;
			must_redraw = 0;
            		QString myfic;
            		QStringList::Iterator mystrlis = listsfile.begin();
            		myfic = *mystrlis;
			//
            		int i = myfic.lastIndexOf( '/' );
            		if ( i != -1 )
            		{
                		path_photos_import = myfic.mid(0,i);
            		}
			//
			QPixmap wl_pix_1;
			QPixmap wl_pix_2(97,77);
			QPixmap wl_pix_3(83,63);
			QPainter p;
			QIcon myicon;
			QString outfilename;
			int wl_random_value;
	
			while( mystrlis != listsfile.end() && nbre_photos < 399 )
            		{
        			myfic = *mystrlis;

				if ( wl_pix_1.load(myfic) == true )
				{
					if ( lst_transitions_2->currentIndex() == 25 )
					{
						wl_random_value = rand()%24;
					}
					else
					{
						wl_random_value = lst_transitions_2->currentIndex();
					}
					// *** Creation de la miniature pour la timeline ***
					wl_pix_2 = wg_diapositive;
					myicon = lst_transitions_2->itemIcon(wl_random_value);
					if ( wl_pix_1.height() > wl_pix_1.width() )
					{
						wl_pix_3 = wl_pix_1.scaledToHeight ( 63, Qt::FastTransformation );
					}
					else
					{
						wl_pix_3 = wl_pix_1.scaledToWidth ( 83, Qt::FastTransformation );
					}
        				p.begin(&wl_pix_2);
					p.drawPixmap(7 + ((83 - wl_pix_3.width()) / 2), 7 + ((63 - wl_pix_3.height()) / 2), wl_pix_3, 0, 0, 83, 63 );
					myicon.paint ( &p, 56, 45, 32, 24, Qt::AlignCenter, QIcon::Normal, QIcon::On );
					p.end();
					nbre_new = nbre_new + 1;
					//
            				i = myfic.lastIndexOf( '/' );
            				if ( i != -1 )
            				{
                				outfilename = myfic.mid(i + 1, myfic.length() - (i + 1));
						QFile::copy ( myfic, wpathprojet + "/" + outfilename );
						//wl_pix_1.save(wpathprojet + "/" + outfilename + ".png","PNG",75);
						//
						nbre_photos = nbre_photos + 1;
						//table_photos[nbre_photos][0] = outfilename + ".png";
						table_photos[nbre_photos][0] = outfilename;
						table_photos[nbre_photos][1] = "0";
						table_photos[nbre_photos][2] = "0";
						table_photos[nbre_photos][3] = "-4";
						table_photos[nbre_photos][4] = "0";
						table_photos[nbre_photos][5] = "0";
						table_photos[nbre_photos][6] = "0";
						table_photos[nbre_photos][7] = "0";
						table_photos[nbre_photos][8] = "0";
						table_photos[nbre_photos][9] = "-4";
						table_photos[nbre_photos][10] = "0";
						table_photos[nbre_photos][11] = "0";
						table_photos[nbre_photos][12] = "0";
						table_photos[nbre_photos][13] = "$N$U$L$L";
						table_photos[nbre_photos][14] = "0";
						table_photos[nbre_photos][15] = "30";
						table_photos[nbre_photos][16] = QString::number(spindurdiapo_2->value());
						table_photos[nbre_photos][17] = "";
						table_photos[nbre_photos][18] = "0";
						table_photos[nbre_photos][19] = "0";
						table_photos[nbre_photos][20] = QString::number(wl_random_value);
						table_photos[nbre_photos][21] = QString::number(spindurtrans_2->value());
						table_photos[nbre_photos][22] = "0";
						table_photos[nbre_photos][23] = "0";
						table_photos[nbre_photos][24] = "";
						table_photos[nbre_photos][25] = "60";
						table_photos[nbre_photos][26] = "60";
						table_photos[nbre_photos][27] = "0";
						table_color_fog[nbre_photos] = QColor(128,128,128);
						//
        					QLabel *mylabel = new QLabel(timeline);
						mylabel->installEventFilter(this);
						table_pnt_img[nbre_photos] = mylabel;
        					mylabel->setGeometry( ((nbre_photos * 97) + (nbre_photos * 10)), 0, 97, 77);
        					mylabel->setPixmap ( wl_pix_2 );
        					mylabel->show();
					}
				}
				else
				{
					QMessageBox::information(this, "Manslide", tr("Echec du chargement de l'image : ") + myfic);
				}
				//
				++mystrlis;
			}
			current_diapo = nbre_photos;
			img_selection->show();
			img_selection->setGeometry( ((nbre_photos * 97) + (nbre_photos * 10)), 0, 97, 77);
			img_selection->raise();
			//
			if ( ((nbre_photos + 1) * 110) - 740 > 0 )
			{
				scroll_timeline->setMaximum(((nbre_photos + 1) * 110) - 740);
			}
			//
			if ( nbre_photos >= 0 )
			{
				if ( nbre_new > 0 )
				{
					pntmygl->txt_sur_image = table_photos[current_diapo][17];
					pntmygl->wg_duree = spindurdiapo_2->value();
					pntmygl->pause_debut = 0;
					pntmygl->pause_fin = 0;
					comboposlegende->setCurrentIndex(0);
					spindurdiapo->setValue(spindurdiapo_2->value());
					spindurtrans->setMaximum(5);
					spindurtrans->setValue(spindurtrans_2->value());
					lst_transitions->setCurrentIndex(table_photos[current_diapo][20].toInt());
				}
				//
				group_support->setEnabled(true);
				bt_start_new->setEnabled(true);
				bt_save_proj->setEnabled(true);
				bt_supprime_diapo->setEnabled(true);
				frame_ed3d->setEnabled(true);
				bt_copy_all->setEnabled(true);
				bt_play->setEnabled(true);
				bt_stop->setEnabled(true);
				bt_start->setEnabled(true);
				bt_end->setEnabled(true);
				param_diapo->setEnabled(true);
				bt_img_effects->setEnabled(true);
				bt_fond->setEnabled(true);
				bt_screenshot->setEnabled(true);
				frame_toptimeline->setEnabled(true);
				contain_timeline->setEnabled(true);
				affichage_diapo();
				f_calcul_son();
			}
		}
        }
	else
	{
		QMessageBox::information(this, "Manslide", tr("le nombre maximum de diapos est de 400. Desole ..."));
	}
}

void mainfrm::f_scroll_timeline(int valeur)
{
	if (valeur >= 0)
	{
		timeline->setGeometry(0-valeur,0,50000,112);
	}
}

void mainfrm::keyPressEvent( QKeyEvent *k )
{
// *** Gestion du clavier *** 
    	if ( k->key() == Qt::Key_Escape)
    	{
    	}
}

bool mainfrm::eventFilter(QObject *o, QEvent *e)
{
// ***************************
// *** Filtrage des events ***
// ***************************
    	if ( contain_timeline->isEnabled() == true )
    	{
        	if (e->type() == QEvent::MouseButtonPress )
        	{
            		int i = 0;
            		while (table_pnt_img[i] != o && i < 400)
            		{
                		i = i + 1;
            		}
            		if (table_pnt_img[i] == o)
            		{
				must_redraw = 0;
				current_diapo = i;
                		affichage_diapo();
            		}
        	}
	}
	return QDialog::eventFilter(o,e);
}

void mainfrm::affichage_diapo()
{
	pntmygl->type3D = table_photos[current_diapo][27].toInt();
	if ( table_photos[current_diapo][27] == "0" )
	{
		plane->setChecked(true);
	}
	else
	{
		if ( table_photos[current_diapo][27] == "1" )
		{
			flag->setChecked(true);
		}
		else
		{
			if ( table_photos[current_diapo][27] == "2" )
			{
				cube->setChecked(true);
			}
		}
	}
	lcdcurrent->display(current_diapo + 1);
	pntmygl->txt_sur_image = table_photos[current_diapo][17];
	legende_image->setText(table_photos[current_diapo][17]);
	pntmygl->effet_titre = table_photos[current_diapo][23].toInt();
	comboposlegende->setCurrentIndex(table_photos[current_diapo][23].toInt());
       	pntmygl->debut_px = table_photos[current_diapo][1].toFloat();
       	pntmygl->debut_py = table_photos[current_diapo][2].toFloat();
       	pntmygl->debut_pz = table_photos[current_diapo][3].toFloat();
       	pntmygl->debut_rx = table_photos[current_diapo][4].toFloat();
       	pntmygl->debut_ry = table_photos[current_diapo][5].toFloat();
       	pntmygl->debut_rz = table_photos[current_diapo][6].toFloat();
	//
       	pntmygl->fin_px = table_photos[current_diapo][7].toFloat();
       	pntmygl->fin_py = table_photos[current_diapo][8].toFloat();
       	pntmygl->fin_pz = table_photos[current_diapo][9].toFloat();
       	pntmygl->fin_rx = table_photos[current_diapo][10].toFloat();
       	pntmygl->fin_ry = table_photos[current_diapo][11].toFloat();
       	pntmygl->fin_rz = table_photos[current_diapo][12].toFloat();
	//
	pntmygl->rotationX = table_photos[current_diapo][4].toFloat();
	pntmygl->rotationY = table_photos[current_diapo][5].toFloat();
	pntmygl->rotationZ = table_photos[current_diapo][6].toFloat();
	pntmygl->zoom = table_photos[current_diapo][3].toFloat();
	pntmygl->deplacementX = table_photos[current_diapo][1].toFloat();
	pntmygl->deplacementY = table_photos[current_diapo][2].toFloat();
	pntmygl->path_fond = table_photos[current_diapo][13];
	pntmygl->wg_percent = table_photos[current_diapo][25].toFloat() / 100;
	dial_percent_blending->setValue(table_photos[current_diapo][25].toInt());
	dial_percent_blending_2->setValue(table_photos[current_diapo][26].toInt());
	label_percent_1->setText( table_photos[current_diapo][25] + " %");
	label_percent_2->setText( table_photos[current_diapo][26] + " %");
	//
	if ( table_photos[current_diapo][14] == "1" )
	{
		pntmygl->fogcolor[0] = (float)table_color_fog[current_diapo].red() / (float)255;
		pntmygl->fogcolor[1] = (float)table_color_fog[current_diapo].green() / (float)255;
		pntmygl->fogcolor[2] = (float)table_color_fog[current_diapo].blue() / (float)255;
		pntmygl->fogcolor[3] = 0.5;
		pntmygl->isfog = 1;
		check_fog->setChecked(true);
		dial_opacity->setValue(table_photos[current_diapo][15].toInt());
		pntmygl->change_fog_color();
	}
	else
	{
		pntmygl->isfog = 0;
		check_fog->setChecked(false);
	}
	//
	pntmygl->wg_duree = table_photos[current_diapo][16].toInt();
	spindurpausefirst->setValue(table_photos[current_diapo][19].toInt());
	spindurpauselast->setValue(table_photos[current_diapo][18].toInt());
	//
	if ( table_photos[current_diapo][22] != "0" )
	{
		int idxsearch = 1;
		QString nomeffet = table_photos[current_diapo][22];
		while ( nomeffet != pntmygl->table_effets[idxsearch][0] && idxsearch < 39 )
		{
			idxsearch = idxsearch + 1;
		}
		if ( idxsearch < 39 )
		{
			comboeffets->setCurrentIndex(idxsearch);
		}
		else
		{
			comboeffets->setCurrentIndex(0);
		}
	}
	else
	{
		comboeffets->setCurrentIndex(0);
	}
	//
	spindurdiapo->setValue(table_photos[current_diapo][16].toInt());
	spindurtrans->setMaximum(table_photos[current_diapo][16].toInt());
	spindurtrans->setValue(table_photos[current_diapo][21].toInt());
	//
	title_comment->setText(table_photos[current_diapo][24]);
	//
	if ( table_photos[current_diapo][20] == "0" )
	{
		lst_transitions->setCurrentIndex(0);
	}
	else
	{
		lst_transitions->setCurrentIndex(table_photos[current_diapo][20].toInt());
	}
	//
	pntmygl->wg_duree = table_photos[current_diapo][16].toInt();
	pntmygl->pause_debut = table_photos[current_diapo][19].toInt();
	pntmygl->pause_fin = table_photos[current_diapo][18].toInt();
	pntmygl->sl_charge_image(wpathprojet + "/" + table_photos[current_diapo][0], wpathprojet + "/" + table_photos[current_diapo][13]);
	pntmygl->updateGL();
	//
	position_flux = 0;
	//
	img_selection->setGeometry( ((current_diapo * 97) + (current_diapo * 10)), 0, 97, 77);
}

void mainfrm::f_transition_changed(int myindex)
{
	if ( nbre_photos >= 0 && must_redraw == 0 )
	{
		QLabel *mylabel;
		mylabel = table_pnt_img[current_diapo];
		QPixmap wl_pix_1(wpathprojet + "/" + table_photos[current_diapo][0]);
		QPixmap wl_pix_2(wg_diapositive);
		QPixmap wl_pix_3(83,63);
		if ( wl_pix_1.height() > wl_pix_1.width() )
		{
			wl_pix_3 = wl_pix_1.scaledToHeight ( 63, Qt::FastTransformation );
		}
		else
		{
			wl_pix_3 = wl_pix_1.scaledToWidth ( 83, Qt::FastTransformation );
		}
		QPainter p;
		p.begin(&wl_pix_2);
		p.drawPixmap(7 + ((83 - wl_pix_3.width()) / 2), 7, wl_pix_3, 0, 0, 83, 63 );
		QIcon myicon = lst_transitions->itemIcon(myindex);
		myicon.paint ( &p, 56, 45, 32, 24, Qt::AlignCenter, QIcon::Normal, QIcon::On );
		if ( table_photos[current_diapo][24] != "" )
		{
			p.drawPixmap(2, 57, wg_comment, 0, 0, -1, -1 );
		}
		p.end();
		mylabel->setPixmap(wl_pix_2);
		//
		table_photos[current_diapo][20] = QString::number(myindex);
	}
}

void mainfrm::f_transition_duree_changed(int myduree)
{
	table_photos[current_diapo][21] = QString::number(myduree);
}

void mainfrm::start_play()
{
	bt_play->setDisabled(true);
	bt_start->setDisabled(true);
	bt_end->setDisabled(true);
	frame_toptimeline->setDisabled(true);
	//
	frame_parametres->hide();
	frame_topmenu->setDisabled(true);
	frame_parameters->setDisabled(true);
	frame_telecomm->setDisabled(true);
	contain_timeline->setDisabled(true);
	//
	pntmygl->wg_duree = table_photos[current_diapo][16].toInt();
	pntmygl->txt_sur_image = table_photos[current_diapo][17];
	pntmygl->effet_titre = table_photos[current_diapo][23].toInt();
	pntmygl->pause_debut = spindurpausefirst->value();
	pntmygl->pause_fin = spindurpauselast->value();
	pntmygl->start_opacity = table_photos[current_diapo][25].toFloat() / 100;
	pntmygl->end_opacity = table_photos[current_diapo][26].toFloat() / 100;
	pntmygl->sl_play();
}

void mainfrm::stop_play()
{
	position_flux = 0; 
	bt_play->setEnabled(true);
	bt_start->setEnabled(true);
	bt_end->setEnabled(true);
	frame_toptimeline->setEnabled(true);
	pntmygl->sl_stop();
	//
	frame_topmenu->setEnabled(true);
	frame_parameters->setEnabled(true);
	frame_telecomm->setEnabled(true);
	contain_timeline->setEnabled(true);
	//
}
